////////////////////// FROM INDISS :///////////////////////////////////


#include "composer/composer.h"
#include "composer/JRMPComposer.h"
#include "unit/unit.h"
#include "protocol/ssdpmsg.h"

#include "io/io.h"
#include <stdio.h>
#include "event/eventqueue_table.h"
#include <pthread.h>


#include "monitor/tools.h"


//////////////// FROM NEMESYS : ///////////////////////






#include <stdio.h>
#include "protocol/rmi.h"

#include "event/servicedef.h"


#include <io/jtype.h>
#include <io/io.h>
#include <io/jconst.h>
#include <ser/objectparser.h>

#include <nanohttp/nanohttp-client.h>
#include <vm/jclass.h>
#include <vm/jmethods.h>

#include <time.h>
#include <limits.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdio.h>
//#include <linux/in.h>
#include <arpa/inet.h> 
#include <netinet/in.h>



#include "sha/sha.h"












/*



#include <stdio.h>
#include "protocol/rmi.h"

#include "event/servicedef.h"


#include <io/jtype.h>
#include <io/io.h>
#include <io/jconst.h>
#include <ser/objectparser.h>

#include <nanohttp/nanohttp-client.h>
#include <vm/jclass.h>
#include <vm/jmethods.h>

#include <time.h>
#include <limits.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdio.h>
#include <linux/in.h>


#include "sha/sha.h"

*/


//char* get_method_signature(ARGUMENTDEFPTR args, char* returnType);
//j_long calc_method_hash(char* hash_method_name);
char* parseJRMP_receiveStub(int fd, j_long* objNum, int* objId, j_long* objTime, short* objCount, int* objPort);





int open_fd_client(char* address, int port)
{
    char c;
    FILE *fp;
    int fromlen;
    register int i, s, ns, len;
    struct sockaddr_in sain, fsain;

    /*
     * Get a socket to work with.  This socket will
     * be in the UNIX domain, and will be a
     * stream socket.
     */
    if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
        perror("server: socket");
        exit(1);
    }

    /*
     * Create the address we will be binding to.
     */
    bzero((char*)&sain,sizeof(sain));
    sain.sin_family = AF_INET;      
    
    //int inet_aton (const char *cp, struct in_addr *inp);
    inet_aton(address, &(sain.sin_addr));
    
    sain.sin_port = htons(port);


    /*
     * Try to bind the address to the socket.  We
     * unlink the name first so that the bind won't
     * fail.
     *
     * The third argument indicates the "length" of
     * the structure, not just the length of the
     * socket name.
     */
//    unlink(ADDRESS);
    //len = sizeof(saun.sun_family) + strlen(saun.sun_path);
    len = sizeof(sain);


    if (connect(s, (struct sockaddr *)&sain, len) < 0) {
        perror("server: connect ");
	fprintf(stdout,"server: connect to port %d", port);
        exit(1);
    }


    fprintf(stdout,"\nClient connected to Server. client port is %d\n",sain.sin_port);
    /*
     * We'll use stdio for reading the socket.
     */
//    fp = fdopen(ns, "rw");
//    int fp = open(ns, "r");
//    return fp;


    return s;
    /*
     * We can simply use close() to terminate the
     * connection, since we're done with both sides.
     */
   // close(s);
 // }
}


void writeJRMPHeader_Header(int fdIn)
{
    fprintf(stdout,"\nHeader RMI: ");
		
    writejInt(fdIn, Magic);
    fprintf(stdout,"\nWrite RMI Magic: %x \n", Magic);

    writejShort(fdIn, Version);
    fprintf(stdout,"\nWrite RMI version: %x \n", Version);
	
    writejByte(fdIn, StreamProtocol);
    fprintf(stdout,"\nWrite RMI StreamProtocol: %x \n", StreamProtocol);
}

void parseJRMPHeader_Ack(int fdIn)
{
    j_byte ack;
    parsejByte(fdIn, &ack);
    if (ack != ProtocolAck)
    {
	fprintf(stdout,"\nErr RMI ProtocolAck\n");
	return;
    }
    else
    {
	fprintf(stdout,"\nProtocolAck: %x OK\n",ack); 
    }   
}

void parseJRMPHeader_Address_Port(int fdIn)
{
  char* addr = parsejUTF8String(fdIn);
  fprintf(stdout,"\nAddress : %s \n", addr);

  j_byte port1;
  parsejByte(fdIn, &port1);
  j_byte port2;
  parsejByte(fdIn, &port2);
  j_byte port3;
  parsejByte(fdIn, &port3);
  j_byte port4;
  parsejByte(fdIn, &port4);

  int portX = (port4&0xff) | (port3&0xff)<<8 | (port2&0xff)<<16 | (port1&0xff)<<24;
  fprintf(stdout,"\nPort : %02x %02x %02x %02x. portX =%d portY =%d portZ =%d\n", port1, port2, port3, port4, portX);
}


void writeJRMPHeader_Address_Port(int fdOut)
{

  UTF8_PTR addrClient = stringToUTF8("127.0.0.1");
  writejUtf8(fdOut, addrClient);


   j_int clientPort = 1234;
   writejInt(fdOut, clientPort);
   fprintf(stdout,"ClientPort: %d\n",clientPort);
}


int writeJRMPHeader(int fdIn) 
{

    int fdOut = fdIn;
    
    writeJRMPHeader_Header(fdIn);

	//Protocol negociation 
	//We must receive an acklong 
    parseJRMPHeader_Ack(fdIn);

	//Suggest endPoint
	//We must read suggested host
	 //remoteHost
    parseJRMPHeader_Address_Port(fdIn);


    writeJRMPHeader_Address_Port(fdOut);
		
    return fdIn;	
}








int writeObjHeader(int fd)
{
fprintf(stdout,">>P.HEADER \n");
	j_short magic1 = 0xaced;
	j_short version1 = STREAM_VERSION;

	writejShort(fd, magic1);
	writejShort(fd, version1);
	
	fprintf(stdout,"magic: %x\n",magic1);
	fprintf(stdout,"version: %x\n",version1);
}



/**
 *  Parse l'identifiant de l'objet
 *  //long objNum + UID space
 *  //UID= int unique + long time + short count
 * @throws IOException
 * 
 //Parsing de l'object Identifier
//=>
//<=
//End ObjectIdentifier
 * 
 */
int writeJRMP_ObjID(int fd, j_byte length, j_long objNum, j_int unique, j_long time, j_short count) 
{

    //Parse Header of the stream
    fprintf(stdout,">>HEADER Object Stream\n");

    writeObjHeader(fd);
			
    //TC_BLOCKDATA
    j_byte code = TC_BLOCKDATA;
    fprintf(stdout,"code is %x",code);
    writejByte(fd, code);
    
    //j_byte length = 34;
    writejByte(fd, length);
    

    fprintf(stdout,"\nnbBytes= %d\n",length);

    // write objNum
    j_int i1 = 0x00, i2 = 0x00;
    writejInt(fd, i1);
    writejInt(fd, i2);
    //j_long objNum  = ((j_long) i1 << 32) + (i2 & 0xFFFFFFFFL);
    
    //j_int unique = 0;
    writejInt(fd, unique);
			
    //j_long time = 0;
    writejLong(fd, time);
    
    //j_short count = 0;
    writejShort(fd, count);

    fprintf(stdout,"\nObjID=> ");
    fprintf(stdout,"\n\tObjUnum: %d",objNum);
    fprintf(stdout,"\n\tunique= %d",unique);
    fprintf(stdout,"\n\ttime= %d",time);
    fprintf(stdout,"\n\tcount= %d",count);				
}




//void composeJRMP_lookup(char* ip, int port, long long* objNum, int* objId, long long* objTime, short* objCount, int* objPort, JMETHODS_PTR meths /*char* methNames[], char* methSignatures[],  int* nMeth*/)

void composeJRMP_lookup(char* ip, int port, char* name , /*long long* objNum, int* objId, long long* objTime, short* objCount, int* objPort, 
JMETHODS_PTR meths,*/ 
		int stream_id, void* evt_src, COMPOSER_PTR composer /*char* methNames[], char* methSignatures[],  int* nMeth*/)
{

	long long objNum;
	int objId; 
	long long objTime;
	short objCount; 
	int objPort;
	JMETHODS_PTR meths = create_JMethods();
	
    int fd = (open_fd_client(ip, port));

    writeJRMPHeader(fd);
    
    
    // type for Lookup is "Call"
	//write code
    j_byte code = Call;
	writejByte(fd, code);
    fprintf(stdout,"Code: %x=Call\n",code);
    
    
    
    //writeJRMP_MsgObjID(fd);
    writeJRMP_ObjID(fd, 34, 0, 0, 0, 0); 
    
     // Writing operation number
     //j_int opNum = -1; //jdk1.2
     j_int opNum = 2; //jdk 1.1
     writejInt(fd, opNum);	

     // Writing hash code for the operation		
     //j_long hash = -7538657168040752697ULL;  //jdk1.2
     j_long hash = RMI_LOOKUP_HASH; //4905912898345647071ULL; //jdk 1.1   ????
     writejLong(fd, hash);
				

  //   fflush(stdout);


	j_byte b = TC_STRING;
	fprintf(stdout,"code is %x\n",b);
//	fflush(stdout);
	writejByte(fd, b);		
							


	fprintf(stdout,"<>Lookup() Method\n");
//	fflush(stdout);
	// Write the String that corresponds to the name
	// of the remote object to search 

	//char* str  =  "washer";
	//UTF8_PTR nameSearched = stringToUTF8("rmi://192.168.2.2:1099/washer");
	UTF8_PTR nameSearched = stringToUTF8(name);
	//UTF8_PTR nameSearched = stringToUTF8("ECHOES");
	//UTF8_PTR nameSearched = stringToUTF8("defaultPkg.tv0");
	writejUtf8(fd, nameSearched);

//	fflush(stdout);
	fprintf(stdout,"<>Service searched: %s\n",name);
//	fflush(stdout);

	// Parse the input stream received that contains the
 	// stub of the remote object
	char* stub_location = parseJRMP_receiveStub(fd, &objNum, &objId, &objTime, &objCount, &objPort);
//	fflush(stdout);

	if (stub_location != NULL)
	{
		//Il faudrait envoyer le Stub correspondant au nom
			//Avec lequel il a t associ
	
		int argc = 2;
		char* argv[2];
		argv[0] = "http://192.168.2.2:8080";
		argv[1] = "http://192.168.2.2:8080";
		if (httpc_init(argc, argv)) {
			fprintf(stdout,"Can not init httpc");
	        }
	
		httpc_conn_t* httpConn= httpc_new();
		hresponse_t* out;

		char stub_location_tmp[255];
		//replace_dot_with_slash(stub_location, stub_location_tmp);
		stub_location[strlen(stub_location) - strlen("_Stub")] = '\0';
		strcat(stub_location, ".class");

		//const char *urlstr = "http://192.168.2.2:8080/tmp/washer_rmislp/WasherImpl.class";

		httpc_get(httpConn, &out, stub_location /*urlstr*/);
		fprintf(stdout,"\nHttp Get  %s\n", stub_location);
		fprintf(stdout,"\t Desc = %s \n",out->desc);
	
		char in_str[100000];
		int bytesRead = http_input_stream_read(out->in, (byte_t*)in_str, 100000);
		fprintf(stdout,"\t Byte Read = %d \n",bytesRead);
		fprintf(stdout,"\t in str =  %s\n",in_str);
	
	//	fflush(stdout);	
	
		JCLASS_PTR jclass = class_parse_charPtr(in_str);
	
		class_print_pool(jclass,7);
	
	//fprintf(stdout, "\n\t JRMPCOmposer methNames addr before= %d ",methNames);
		get_public_methods(jclass, meths /*methNames, methSignatures, nMeth*/);
	//fprintf(stdout, "\n\t JRMPCOmposer methNames addr after= %d ",methNames);
	
	//	int i;
	//     for (i=0; i<meths->nMeths; i++) {
		
		composer_publish_event(event_create(SDP_SERVICE_DESCRIPTION, stream_id, evt_src), composer);
		
		composer_publish_event(event_create(SCP_RMI, stream_id, evt_src), composer);
		
		composer_publish_event(event_create_longlong(SCP_RMIOBJ_NUM, objNum, stream_id, evt_src), composer);
		composer_publish_event(event_create_int(SCP_RMIOBJ_UNIQUE, objId, stream_id, evt_src), composer);
		composer_publish_event(event_create_longlong(SCP_RMIOBJ_TIME, objTime, stream_id, evt_src), composer);
		composer_publish_event(event_create_int(SCP_RMIOBJ_COUNT, objCount, stream_id, evt_src), composer);
		composer_publish_event(event_create_int(SCP_RMIOBJ_PORT, objPort, stream_id, evt_src), composer);
		
		/*
		objId, objTime, objCount, objPort
		EVENT_PTR event_create_int(int type, int value, int stream_id, void* src);
		SCP_RMIOBJ_NUM		=	600,
		SCP_RMIOBJ_UNIQUE	=	601,
		SCP_RMIOBJ_TIME		=	602,
		SCP_RMIOBJ_COUNT		=	603,
		SCP_RMIOBJ_IP		=	604,
		SCP_RMIOBJ_PORT		=	605,
		long long* objNum, int* objId, long long* objTime, short* objCount
		*/
		
		
		char* class_name_tmp = (char*)class_get_classname(jclass);
		fprintf(stdout, "\n\t JRMPComposer : class name = %s",class_name_tmp);
		
		// replace "/" with "." in class_name_tmp
		char* class_name = malloc(strlen(class_name_tmp)+1);
		int i;
		for (i=0; i<strlen(class_name_tmp); i++)
			if (class_name_tmp[i] == '/')
				class_name[i] = '.';
			else
				class_name[i] = class_name_tmp[i];
		class_name[strlen(class_name_tmp)] =  '\0';
		
		lnode_t* node;
		for(node = list_first(meths->methods); node != 0; node = list_next(meths->methods, node))
		{
			JMETHOD_PTR meth = (JMETHOD_PTR)lnode_get(node);
		
			fprintf(stdout, "\n\t JRMPCOmposer Method : name = %s, signature=%s argname[0]=%s argtype[0]=%s", meth->methName, meth->methSignature, meth->args_names[0], meth->args_types[0]);
			
			METHODDEFPTR methoddef = methoddef_new2();
			methoddef_set_name(methoddef, meth->methName);
			int i;
			for (i=0; i<meth->nArgs; i++)
			{
				ARGUMENTDEFPTR arg = argumentdef_new();
				argumentdef_set_name(arg, meth->args_names[i]);
				argumentdef_set_dir(arg, ARG_IN);
				argumentdef_set_datatype(arg, meth->args_types[i]);
				methoddef_add_argument(methoddef, arg);
			}
			methoddef_print(methoddef);
			
	
		    EVENT_METHOD_DEF_PTR event_methoddef = malloc(sizeof(EVENT_METHOD_DEF));
		    event_methoddef->method = methoddef;
		    event_methoddef->interface_name = strdup(class_name);
		    event_methoddef->service_name = name /*"washer"*/;
	    	composer_publish_event(event_create_void_pointer(SDP_SERVICE_METHOD_DESCRIPTION, (void*)event_methoddef, stream_id, evt_src), composer);
	    	
			
		}
		composer_publish_event(event_create(SDP_STOP, stream_id, evt_src), composer);
	//     }
	
		
	//	fflush(stdout);	
	}
}





int composeJRMP_Call(char* ip, int portRMI, SERVICEDEFPTR servicedef, /*METHODDEFPTR  method_from_servicedef,*/ METHODDEFPTR methodDef,
		int stream_id, void* evt_src, COMPOSER_PTR composer) {
	
    int fd = (open_fd_client(ip, portRMI));

    writeJRMPHeader(fd);
    
    j_long objNum = servicedef->RMI_ObjNum;
    j_int unique = servicedef->RMI_ObjUnique;
    j_long time = servicedef->RMI_ObjTime;
    j_short count = servicedef->RMI_ObjCount;

	//write code
    j_byte code = Call;
	writejByte(fd, code);
    fprintf(stdout,"Code: %x=Call\n",code);
	

    // FIXED RETURN VALUE AS INTEGER: TO BE EXTENDED TO SUPPORT ALL POSSIBLE VALUES
    char* methSignature = get_method_signature(methodDef/*method_from_servicedef*/->args, "I");
    char hash_method_name[1000];
    strcpy(hash_method_name, /*method_from_servicedef*/methodDef->name);
    strcat(hash_method_name, methSignature);
    
    //makeRMICall(fdOut, objNum, unique,  time,  count , hash_method_name); 

	//	length= 34 bytes for packet without any Arguments
	/* 
	 * objNum, unique, time, count must correspond
	 * exactly to the values associated to the remote
	 * object and provided by RMI registry lookup call
	 * otherwise a NoSuchObjectException is raised
	 *
	 *			
	 */
    int SIZE_RMI_PACKET = 34;
    int size = SIZE_RMI_PACKET;
    ARGUMENTDEFPTR args_tmp = /*method_from_servicedef*/methodDef->args;
    while (args_tmp != NULL)
    {
    	if (strcmp(args_tmp->datatype, "int") == 0 || strcmp(args_tmp->datatype, "I")==0)
    		size += 4;
    	args_tmp = args_tmp->next;
    }
    writeJRMP_ObjID(fd, size /*34 + 4*1*/, objNum, unique, time, count);

			
	//Parsing du numero de l'operation
	//Si <0 alors jdk1.2
	//Si >0 alors jdk1.1		
	
	//j_int opNum = -1; //jdk1.2
	j_int opNum = -1; //jdk 1.1
	writejInt(fd, opNum);		
	//j_long hash = -7538657168040752697ULL;  //jdk1.2
	//j_long hash = 6789062971934848498ULL; // --> t() : no args
	//j_long hash = -8053588565580120904ULL; // titi() : 3 integers args
	//j_long calcHash = -7490036490156607834ULL; //SetState

	j_long calcHash = calc_method_hash(hash_method_name);
	writejLong(fd, calcHash);

	// Add Arguments Values
	args_tmp = methodDef->args;
    while (args_tmp != NULL)
    {
    	if (strcmp(args_tmp->datatype, "int") == 0 || strcmp(args_tmp->datatype, "I")==0)
    		writejInt(fd, (j_int) atoi(args_tmp->value));
    	args_tmp = args_tmp->next;
    }
			
	// if I dont write a final zero-byte after the end of the stream (not required in specifications)
	// the last byte of the return value of the RMI call is not read from the return stream
	writejByte(fd, 0);
    
	   parseJRMP_receiveStub_Return(fd);
	   parseJRMP_receiveStub_Header(fd);

	   parseJRMP_receiveStub_BLOCKDATA(fd);

	   parseJRMP_receiveStub_RemotePort(fd);

	   parseJRMP_receiveStub_NormalReturn(fd);
	   
	   
	
	// read 0x51 return
	//j_byte x1;
	//parsejByte(fd, &x1);
	//fprintf(stdout,"\nread=>%02x",x1&0xff);

	//parseObjectOutputStream(fd);	
	   
	j_int ret_unique;
    j_long ret_time;
    j_short ret_count;

    parsejInt(fd, &ret_unique);
    parsejLong(fd, &ret_time);
    //parsejShort(fd, &ret_unique);
    parsejShort(fd, &ret_count);
    
    fprintf(stdout,"\tunique= %i / ret_unique=%i\n",unique, ret_unique);
    fprintf(stdout,"\ttime= %llu / ret_time=%llu\n",time, ret_time);
    fprintf(stdout,"\tcount= %i / ret_count=%i\n",count , ret_count);
	
    
    
    // dispatch events describing the RMI reply
    composer_publish_event(event_create(SDP_START, stream_id,(void*)evt_src), composer);	
    composer_publish_event(event_create(SCP_RMI, stream_id, (void*)evt_src), composer);
    composer_publish_event(event_create(SCP_RESPONSE, stream_id, (void*)evt_src), composer);
    composer_publish_event(event_create_string(SCP_METHOD_NAME, methodDef->name, stream_id, (void*)evt_src), composer);
	
	
    // Parse Return Value
	args_tmp = methodDef->args;
    while (args_tmp != NULL)
    {
    	if (args_tmp->dir == ARG_OUT)
    	{
    		if (strcmp(args_tmp->datatype, "int") == 0 || strcmp(args_tmp->datatype, "I")==0)
    		{
    			j_int ret1;
    			parsejInt(fd, &ret1);
    			
    			sprintf(args_tmp->value,"%d",ret1); 
    			
    			composer_publish_event(event_create_void_pointer(SCP_ARGUMENT_OUT, args_tmp, stream_id, (void*)evt_src), composer);
    		}
    	}
    	args_tmp = args_tmp->next;
    }

	
    composer_publish_event(event_create(SDP_STOP, stream_id, (void*)evt_src), composer);		

	
	
	
 /*   
    int ind_x1;
	j_byte x1;
	
	
	parseObjectOutputStream(fd);
	
	for (ind_x1 = 0; ind_x1 < 100; ind_x1++ )
	{
		parsejByte(fd, &x1);
		fprintf(stdout,"\nread=>%02x",x1&0xff);
	}
*/

/*
j_int intReply1;
parsejInt(fd, &intReply1);
fprintf(stdout,"\nread INT=>%d",intReply1);
*/

	

//	fflush(stdout);	
    
}










/*
 * ReceiveStub functions 
 */
int parseJRMP_receiveStub_Return(int fd)
{
   j_byte ret;
   parsejByte(fd, &ret);
    if (ret != Return)
    {
	fprintf(stdout,"\nErr RMI Return %x\n",ret);
	return;
    }
    else
    {
	fprintf(stdout,"\nProtocol Ret: %x OK\n",ret); 
    }  
}

int parseJRMP_receiveStub_Header(int fd)
{
    //parse header
    j_byte magic1, magic2;
    parsejByte(fd, &magic1);
    parsejByte(fd, &magic2);
    j_short magic = (magic2&0xff) | (magic1&0xff)<<8 ;
    if (magic != STREAM_MAGIC)
    {
	fprintf(stdout,"\nErr RMI Stub Magic %x\n",magic);
	return;
    }
    else
    {
	fprintf(stdout,"\nRMI Stub Magic: %x OK\n",magic); 
    } 

    //Version
    j_byte version1, version2;
    parsejByte(fd, &version1);
    parsejByte(fd, &version2);
    j_short version = (version2&0xff) | (version1&0xff)<<8 ;
    if (version != STREAM_VERSION)
    {
	fprintf(stdout,"\nErr RMI Stub version %x\n",version);
	return;
    }
    else
    {
	fprintf(stdout,"\nRMI Stub version: %x OK\n",version); 
    } 
}


int parseJRMP_receiveStub_BLOCKDATA(int fd)
{
    j_byte blockdata;
    parsejByte(fd, &blockdata);
    if (blockdata != TC_BLOCKDATA)
    {
	fprintf(stdout,"\nErr RMI Stub blockdata %x\n",blockdata);
	return;
    }
    else
    {
	fprintf(stdout,"\nRMI Stub blockdata: %x OK\n",blockdata); 
    } 
}

int parseJRMP_receiveStub_RemotePort(int fd)
{
    j_byte remotePort;
    parsejByte(fd, &remotePort);
    if (remotePort != 15) //???????
    {
	fprintf(stdout,"\nErr RMI Stub blockdata %02x\n",remotePort);
	return;
    }
    else
    {
	fprintf(stdout,"\nRMI Stub blockdata: %02x OK\n",remotePort); 
    } 
}

int parseJRMP_receiveStub_NormalReturn(int fd)
{
    j_byte normalReturn;
    parsejByte(fd, &normalReturn);
    if (normalReturn != NormalReturn) //???????
    {
	fprintf(stdout,"\nErr RMI Stub NormalReturn is %x. Return received is %x\n",NormalReturn, normalReturn);
//	return;
    }
    else
    {
	fprintf(stdout,"\nRMI Stub NormalReturn: %x OK\n",normalReturn); 
    } 
}

int parseJRMP_receiveStub_ObjectID(int fd)
{
    //ID= int, long, short
    j_byte unique1, unique2, unique3, unique4;
    parsejByte(fd, &unique1);
    parsejByte(fd, &unique2);
    parsejByte(fd, &unique3);
    parsejByte(fd, &unique4);
    j_int unique = (unique4&0xff) | (unique3&0xff)<<8 | (unique2&0xff)<<16 | (unique1&0xff)<<24 ;

    j_byte time1, time2, time3, time4, time5, time6, time7, time8;
    parsejByte(fd, &time1);
    parsejByte(fd, &time2);
    parsejByte(fd, &time3);
    parsejByte(fd, &time4);
    parsejByte(fd, &time5);
    parsejByte(fd, &time6);
    parsejByte(fd, &time7);
    parsejByte(fd, &time8);
    //j_long time = (time8&0xff) | (time7&0xff)<<8 | (time6&0xff)<<16 | (time5&0xff)<<24 |(time4&0xff)<<32 | (time3&0xff)<<40 | (time2&0xff)<<48 | (time1&0xff)<<56;
    j_long timeX = (time8&0xff) | (time7&0xff)<<8 | (time6&0xff)<<16 | (time5&0xff)<<24 ;//+(time4&0xff)<<32 ; //+ (time3&0xff)<<40 ; //+ (time2&0xff)<<48 ; //+ (time1&0xff)<<56;
    j_long timeY = (time4&0xff) | (time3&0xff)<<8 | (time2&0xff)<<16 | (time1&0xff)<<24 ;
    j_long time = (timeX&0xff) | (timeY&0xff)<<32; 

    j_byte count1, count2;
    parsejByte(fd, &count1);
    parsejByte(fd, &count2);
    j_short count = (count2&0xff) | (count1&0xff)<<8 ;

    fprintf(stdout,"\nRMI Stub. time1=%x time2=%x time3=%x time4=%x time5=%x time6=%x time7=%x time8=%x\n", time1, time2, time3, time4, time5, time6, time7, time8 ); 

    fprintf(stdout,"\nRMI Stub. \tunique=%d\n \ttime= %llu\n \tcount=%d\n",unique, time, count); 
}



/*
    	long	  objNum;
    	int	  unique;
    	long	  time;         
    	short	  count;
*/
char* parseJRMP_receiveStub(int fd, j_long* objNum, int* objId, j_long* objTime, short* objCount, int* objPort) {
		
   //Attention suppose qu'il n'y a qu'un seul Stub

   parseJRMP_receiveStub_Return(fd);
   parseJRMP_receiveStub_Header(fd);

   parseJRMP_receiveStub_BLOCKDATA(fd);

   parseJRMP_receiveStub_RemotePort(fd);

   parseJRMP_receiveStub_NormalReturn(fd);

   //ID= int, long, short
   parseJRMP_receiveStub_ObjectID(fd);
		
   OBJECTDESCPTR objDesc = parseObjectOutputStream(fd);

   
   fprintf(stdout,"\n\nStub received ");
   fprintf(stdout,"\tObjUnum: %I64d \n",objDesc->objNum);
   fprintf(stdout,"\tunique= %i\n",objDesc->unique);
   //fprintf(stdout,"\ttime= %I64d\n",objDesc->time);
   fprintf(stdout,"\ttime= %llu\n",objDesc->time);
   fprintf(stdout,"\tcount= %i\n",objDesc->count);
   fprintf(stdout,"\tbool= %i\n",objDesc->bool);
   
   fprintf(stdout,"\tannotation: %s \n",objDesc->classDescr->annotation);

   *objNum = objDesc->objNum;
   *objId = objDesc->unique;
   *objTime = objDesc->time;
   *objCount = objDesc->count;
   *objPort = objDesc->port;
   
   
   //while (1) {
	   j_byte b;
	   parsejByte(fd, &b);
	   fprintf(stdout, "byte = %02x",b);
	//   fflush(stdout);	
   //}
	   if (objDesc->classDescr->annotation != NULL)
	   {
		   char stub_location[255];
		   char name[255];
		   replace_dot_with_slash(objDesc->classDescr->name, name);
		   sprintf(stub_location, "%s%s", objDesc->classDescr->annotation, name);
		   return  strdup(stub_location);
	   }
	   else
		   return NULL;
}






/*
void composeJRMP_RmiCall(char* ip, int portRMI, SERVICEDEFPTR servicedef, METHODDEFPTR  method_from_servicedef, METHODDEFPTR methodDef) {
	
    int fdIn = (open_fd_client(ip, portRMI));
    int fdOut = fdIn;

    j_long objNum = servicedef->RMI_ObjNum;
    j_int unique = servicedef->RMI_ObjUnique;
    j_long time = servicedef->RMI_ObjTime;
    j_short count = servicedef->RMI_ObjCount;

    
    writeJRMP_MsgHeader(fdIn);

	//Protocol negociation 
	//We must receive an ack
    parseJRMP_MsgAck(fdIn);

	//Suggest endPoint
	//We must read suggested host
	 //remoteHost
    parseJRMP_MsgAddress_Port(fdIn);


    writeJRMP_MsgAddress_Port(fdOut);


	//write code
    j_byte code = Call;
	writejByte(fdOut, code);
    fprintf(stdout,"Code: %x=Call\n",code);
	

    char* methSignature = get_method_signature(method_from_servicedef->args);
    char hash_method_name[1000];
    strcpy(hash_method_name, method_from_servicedef->name);
    strcat(hash_method_name, methSignature);
    
    makeRMICall(fdOut, objNum, unique,  time,  count , hash_method_name); 

}
*/
/*
void composeJRMP_lookup(char* ip, int port, long long* objNum, int* objId, long long* objTime, short* objCount, int* objPort, JMETHODS_PTR meths )
{

    // type for Lookup is "Call"
    int fd = composeJRMP_msg(ip, port, Call);

     // Writing operation number
     //j_int opNum = -1; //jdk1.2
     j_int opNum = 2; //jdk 1.1
     writejInt(fd, opNum);	

     // Writing hash code for the operation		
     //j_long hash = -7538657168040752697ULL;  //jdk1.2
     j_long hash = 4905912898345647071ULL; //jdk 1.1   ????
     writejLong(fd, hash);
				

     fflush(stdout);


	j_byte code = TC_STRING;
	fprintf(stdout,"code is %x\n",code);
	fflush(stdout);
	writejByte(fd, code);		
							


	fprintf(stdout,"<>Lookup() Method\n");
	fflush(stdout);
	// Write the String that corresponds to the name
	// of the remote object to search 

	char* str  =  "washer";
	//UTF8_PTR nameSearched = stringToUTF8("rmi://192.168.2.2:1099/washer");
	UTF8_PTR nameSearched = stringToUTF8("washer");
	//UTF8_PTR nameSearched = stringToUTF8("ECHOES");
	//UTF8_PTR nameSearched = stringToUTF8("defaultPkg.tv0");
	writejUtf8(fd, nameSearched);

	fflush(stdout);
	fprintf(stdout,"<>Service searched: %s\n",str);
	fflush(stdout);

	// Parse the input stream received that contains the
 	// stub of the remote object
	receiveStub(fd, objNum, objId, objTime, objCount, objPort);
	fflush(stdout);

	//Il faudrait envoyer le Stub correspondant au nom
		//Avec lequel il a t associ

	int argc = 2;
	char* argv[2];
	argv[0] = "http://192.168.2.2:8080";
	argv[1] = "http://192.168.2.2:8080";
	if (httpc_init(argc, argv)) {
		fprintf(stdout,"Can not init httpc");
        }

	httpc_conn_t* httpConn= httpc_new();
	hresponse_t* out;
	//const char *urlstr = "http://192.168.2.2:8080/tmp/washer_rmislp/WasherImpl_Stub.class";
	const char *urlstr = "http://192.168.2.2:8080/tmp/washer_rmislp/WasherImpl.class";
	//const char *urlstr = "http://192.168.2.2:8080/tmp/test/server/EchoServer.class";
	httpc_get(httpConn, &out, urlstr);
	fprintf(stdout,"\nHttp Get  \n");
	fprintf(stdout,"\t Desc = %s \n",out->desc);

	char in_str[100000];
	int bytesRead = http_input_stream_read(out->in, (byte_t*)in_str, 100000);
	fprintf(stdout,"\t Byte Read = %d \n",bytesRead);
	fprintf(stdout,"\t in str =  %s\n",in_str);

	fflush(stdout);	

	JCLASS_PTR jclass = class_parse_charPtr(in_str);

	class_print_pool(jclass,7);

//fprintf(stdout, "\n\t JRMPCOmposer methNames addr before= %d ",methNames);
	get_public_methods(jclass, meths );
//fprintf(stdout, "\n\t JRMPCOmposer methNames addr after= %d ",methNames);

//	int i;
//     for (i=0; i<meths->nMeths; i++) {
	lnode_t* node;
	for(node = list_first(meths->methods); node != 0; node = list_next(meths->methods, node))
	{
		JMETHOD_PTR meth = (JMETHOD_PTR)lnode_get(node);
	
		fprintf(stdout, "\n\t JRMPCOmposer Method : name = %s, signature=%s", meth->methName, meth->methSignature);
	}
//     }

	fflush(stdout);	
}


*/

/*


int composeJRMP_msg(char* ip, int portRMI, int type) {
	
    int fdIn = (open_fd_client(ip, portRMI));
    int fdOut = fdIn;

    //j_byte buf[1024];
    //int len = 7, i;
    
    writeJRMP_MsgHeader(fdIn);

	//Protocol negociation 
	//We must receive an acklong 
    parseJRMP_MsgAck(fdIn);

	//Suggest endPoint
	//We must read suggested host
	 //remoteHost
    parseJRMP_MsgAddress_Port(fdIn);


    writeJRMP_MsgAddress_Port(fdOut);


	//write code
    j_byte code = type; //Call;
	writejByte(fdOut, code);
		
    switch((int)code)
    {
	//////WARNING /////
	//Commence ici le protocole de serialisation //
	//////		WARNING /////	
	case Call:
	   fprintf(stdout,"Code: %x=Call\n",code);
	
           writeJRMP_MsgObjID(fdOut);
			
	//   writeJRMP_MsgOperation(fdIn, callType);				

	   break;
	case Ping:
		fprintf(stdout,"Code: %x =Ping\n",code);
	//	out.write(PingAck);long 
		fprintf(stdout,"Ping Ack written\n");
		break;
	case DGCAck:
		fprintf(stdout,"Code: %x = DGCAck\n",code);
		break;
	default:
		fprintf(stdout,"Code: %x ERROR\n",code);
	//throw new StreamCorruptedException("Don't understand");
    }

    return fdIn;	
}
*/


/*
int writeJRMP_MsgOperation(int fd, int callType) 
{
     j_int opNum = callType;
     //Parsing du numero de l'operation
     //Si <0 alors jdk1.2
     //Si >0 alors jdk1.1		
     //j_int opNum = -1; //jdk1.2
     //j_int opNum = 2; //jdk 1.1
     writejInt(fd, opNum);		
     //j_long hash = -7538657168040752697ULL;  //jdk1.2
     j_long hash = 4905912898345647071ULL; //jdk 1.1
     writejLong(fd, hash);
			
     if (opNum < 0) {
  	fprintf(stdout,"\n\t>>JDK 1.2 Call");
          	
	if (hash == (j_long)7583982177005850366ULL) {
       		opNum = 0;
	}
	else if (hash == 2571371476350237748ULL) {
	 	opNum = 1;
	}
	else if (hash == -7538657168040752697ULL) {
	        opNum = 2;
	}
	else if (hash == -8381844669958460146ULL) {
	      opNum = 3;
	}
	else if (hash == 7305022919901907578ULL) {
	   opNum = 4;
	}
	else {
	    fprintf(stdout,"\n\t>>Method Hash NOT KNOWN");
	}
	//fprintf(stdout,"\n\t>>Hash method=>%dL",hash);
	fprintf(stdout,"\n\t>>Hash method=>%llu",hash);
	fprintf(stdout,"\n\t>>Index Method=>%d",opNum);
     }
     else
     {
	//Hash => hashcode de l'interface remote
	fprintf(stdout,"\n\t<<JDK 1.1 Call");
	//fprintf(stdout,"\n\t<<Hash interface=>%Ld",hash);
	fprintf(stdout,"\n\t<<Hash interface=>%llu",hash);
        fprintf(stdout,"\n\t<<Index Method=>%d",opNum);
	if(hash!=4905912898345647071ULL)
	   fprintf(stdout,"\n\t<<Hash interface NOT KNOWN\n");
	else
	   fprintf(stdout,"\n\t<<Registry interface Ok\n");
     }	
	

     fflush(stdout);	


	j_byte code = TC_STRING;
	fprintf(stdout,"code is %x\n",code);
	fflush(stdout);
	writejByte(fd, code);		
							
	//Attention, On sait ici que le premier argument est un String
	//On doit le vrifier, le checker avec 
	//l'interface correspondant au hash code prcdent.
	//Attention ici on connait l'interface,
	//C'est l'interface du registry
	//On connait donc les mthodes associes et leurs signatures.
			

			
	 // Read the next Code in the Stream.
			
	//Parse directly the content of the next thing in the stream
	//That must be an object as described in the rmi specification
	//Dpend de l'interface Registry
			
	switch(opNum) //Interface Registry
	{
	    case 1: //String[]	list()
	    {
		fprintf(stdout,"<>List() Not implemented\n");
		break;
	    }
	    case 2: // Remote lookup(String name) 
	    {
		fprintf(stdout,"<>Lookup() Method\n");
		fflush(stdout);
		//Parse the String
		//String correspondant au nom du stub rechercher
		//Stub prealablement telecharger 

		char* str  =  "washer";
		UTF8_PTR nameSearched = stringToUTF8("rmi://192.168.2.2:1099/washer");
		//UTF8_PTR nameSearched = stringToUTF8("ECHOES");
		writejUtf8(fd, nameSearched);
		//parsejUTF8String(fd);

		fflush(stdout);
		fprintf(stdout,"<>Service searched: %s\n",str);
		fflush(stdout);
		//FileInputStream fi =new FileInputStream("Stub.bin");
		//ObjectInputStream objin=new ObjectInputStream(fi);
		//Object obj=null;
		//try {
		//	obj = objin.readObject();
		//} catch (IOException e) {
		//	// TODO Auto-generated catch block
		//	e.printStackTrace();
		//} catch (ClassNotFoundException e) {
		//	// TODO Auto-generated catch block
		//	e.printStackTrace();
		//}
		//objin.close();
		//fi.close();

		receiveStub(fd);
		fflush(stdout);
		//Il faudrait envoyer le Stub correspondant au nom
		//Avec lequel il a t associ
	
		j_byte a1;
		parsejByte(fd, &a1);
		fprintf(stdout,"\nReading after end: %02X\n",a1);
		parsejByte(fd, &a1);
		fprintf(stdout,"\nReading after end: %02X\n",a1);
		parsejByte(fd, &a1);
		fprintf(stdout,"\nReading after end: %02X\n",a1);
		parsejByte(fd, &a1);
		fprintf(stdout,"\nReading after end: %02X\n",a1);
		parsejByte(fd, &a1);
		fprintf(stdout,"\nReading after end: %02X\n",a1);
		//System.out.println("Lookup() Not implemented");
		break;
	   }
	   case 0: //void bind(String name, Remote obj) 
	   case 3:	//void rebind(String name, Remote obj)
	   {
		fprintf(stdout,"<>bind() or rebind() Method\n");
		

   		//char* str  = parsejUTF8String(fd);
		//fprintf(stdout,"str = %s\n",str);


		//Il faudrait aussi mettre en cache
		//Le binaire de l'objet parser.
		//Attention ici utiliser des routines autres que celle du jdk 
		//test
			
		//=> invalid stream header
		//We must read the object stream without reading the header.
		//Skip the header is needed but not provided by the jdk
		//=> section de code fait en C
		//
		//	Object obj=null;
		//	ObjectInputStream objIn=new ObjectInputStream(in);
		//	try {
		//		obj=objIn.readObject();
		//	} catch (IOException e) {
		//		// TODO Auto-generated catch block
		//		e.printStackTrace();
		//	} catch (ClassNotFoundException e) {
		//		// TODO Auto-generated catch block
		//		e.printStackTrace();
		//	}
		//	sendVoid();
		//Save the Stub
		//FileOutputStream fo =new FileOutputStream("Stub.bin");
		//ObjectOutputStream objout=new ObjectOutputStream(fo);
		//objout.writeObject(obj);
		//objout.close();
		//fo.close();
					
		//Save the stub to a file
		//uncomment to get the Stub
				
		//int b;
		//int i=0;
		//FileOutputStream fo =new FileOutputStream("Stub1.bin");
					
		//while(peekCode(in)>=0)
		//{
		//	b=parseCode(in);
		//	fo.write(b);
		//	System.out.println(i+": "+toHexString((byte)b));
		//	i++;
		//}
		//System.out.println("end");
		//fo.close();

		//parseObjectOutputStream(fd);

		//sendVoid(fd);
		
		break;
	   }
	   case 4://void unbind(String name)
	   {
		fprintf(stdout,"<>unbind() method\n");
		break;
	   }				
	}			
	
	fprintf(stdout,"END !!!!\n");
	//normal Return
	fprintf(stdout,"Affiche le Stub\n");
			
	fflush(stdout);	
}
*/
/**
 *  Parse l'identifiant de l'objet
 *  //long objNum + UID space
 *  //UID= int unique + long time + short count
 * @throws IOException
 */
/*
int writeJRMP_MsgObjID(int fd) 
{

    //Parse Header of the stream
    fprintf(stdout,">>HEADER Object Stream\n");

    writeObjHeader(fd);
			
    //Parse data
    //peekCode(fd);
    //j_int peek = -1;
    //writejInt(fd, peek);
    //j_byte  code = parseCode(fd); //TC_BLOCKDATA
    j_byte code = TC_BLOCKDATA;
    fprintf(stdout,"code is %x",code);
    writejByte(fd, code);
    j_byte length = 34;
    writejByte(fd, length);
    //byte)(din.read()&0xff)); //Longueur du bloc Data
    fprintf(stdout,"\nnbBytes= %d\n",length);

    j_int i1 = 0x00, i2 = 0x00;
    writejInt(fd, i1);
    writejInt(fd, i2);

    j_long objNum  = ((j_long) i1 << 32) + (i2 & 0xFFFFFFFFL);
    j_int unique = 0; //-200;
    writejInt(fd, unique);
			
    j_long time = 0; //312;
    writejLong(fd, time);
    j_short count = 0; //348;
    writejShort(fd, count);

    fprintf(stdout,"\nObjID=> ");
    fprintf(stdout,"\n\tObjUnum: %d",objNum);
    fprintf(stdout,"\n\tunique= %d",unique);
    fprintf(stdout,"\n\ttime= %d",time);
    fprintf(stdout,"\n\tcount= %d",count);				

//Parsing de l'object Identifier
//=>
//<=
//End ObjectIdentifier
}
*/


int __makeRMICall__(int fd, j_long objNum, j_int unique, j_long time, j_short count, char* hash_method_name) 
{
	//Parse Header of the stream
	fprintf(stdout,">>HEADER Object Stream\n");

    	
	//	length= 34 bytes for packet without any Arguments
	writeJRMP_ObjID(fd, 34 + 4*1, objNum, unique, time, count);
 /*   	
	writeObjHeader(fd);
			
	//Parse data
	//peekCode(fd);
	//j_int peek = -1;
	//writejInt(fd, peek);
	//j_byte  code = parseCode(fd); //TC_BLOCKDATA
	j_byte code = TC_BLOCKDATA;
	fprintf(stdout,"code is %x",code);
	writejByte(fd, code);
	j_byte length = 34 + 4*1; // 34 bytes for packet without any Arguments
	writejByte(fd, length);
	//byte)(din.read()&0xff)); //Longueur du bloc Data
	fprintf(stdout,"\nnbBytes= %d\n",length);



	j_int i1 = 0x00, i2 = 0x00;
	writejInt(fd, i1);
	writejInt(fd, i2);

//	j_long objNum  = ((j_long) i1 << 32) + (i2 & 0xFFFFFFFFL);
//	j_int unique = 32635808; 
	writejInt(fd, unique);
		
//	j_long time = 1140682442693ULL; 

	writejLong(fd, time);
//	j_short count = -32768; 
	writejShort(fd, count);
*/

	/* 
	 * objNum, unique, time, count must correspond
	 * exactly to the values associated to the remote
	 * object and provided by RMI registry lookup call
	 * otherwise a NoSuchObjectException is raised
	 *
	 *
	fprintf(stdout,"\nObjID=> ");
	fprintf(stdout,"\n\tObjUnum: %d",objNum);
	fprintf(stdout,"\n\tunique= %d",unique);
	fprintf(stdout,"\n\ttime= %llu",time);
	fprintf(stdout,"\n\tcount= %d",count);				
*/

	//Parsing de l'object Identifier
	//=>

	//<=
	//End ObjectIdentifier
			
	//Parsing du numero de l'operation
	//Si <0 alors jdk1.2
	//Si >0 alors jdk1.1		
	
	//j_int opNum = -1; //jdk1.2
	j_int opNum = -1; //jdk 1.1
	writejInt(fd, opNum);		
	//j_long hash = -7538657168040752697ULL;  //jdk1.2
	//j_long hash = 6789062971934848498ULL; // --> t() : no args
	//j_long hash = -8053588565580120904ULL; // titi() : 3 integers args


	j_long calcHash = calc_method_hash(hash_method_name);

/*	
    SHA1Context sha;
    int i, j, err;
    uint8_t Message_Digest[20];

    	fprintf(stdout,"NEMESYS:\n");
    	UTF8_PTR utf8string = stringToUTF8(hash_method_name); //"stop(I)Ljava/lang/String;");   //echo(Ljava/lang/String;)Ljava/lang/String;") ;
    	fprintf(stdout,"SHA signature length = %d\n",utf8string->size);
    	fprintf(stdout,"SHA UTF8 string = ",utf8string->size);


    for(i = 0; i < utf8string->size ; ++i)
            {
                fprintf(stdout,"%02X ", utf8string->utf8[i]);
            }
            fprintf(stdout,"\n");



        fprintf( stdout, "\nTest : '%s'\n",
                utf8string->utf8);
//
        err = SHA1Reset(&sha);
        if (err)
        {
            fprintf(stdout, "SHA1Reset Error %d.\n", err );
        }

            err = SHA1Input(&sha,
                  (const unsigned char *) utf8string->utf8,utf8string->size);
		     // strlen(utf8string->utf8) 
            if (err)
            {
                fprintf(stdout, "SHA1Input Error %d.\n", err );
            }


        err = SHA1Result(&sha, Message_Digest);
        if (err)
        {
            fprintf(stdout,
            "SHA1Result Error %d, could not compute message digest.\n",
            err );
        }
        else
        {
            printf("\t");
            for(i = 7; i >= 0 ; i--)
            {
                fprintf(stdout,"%02X ", Message_Digest[i]);
            }
            fprintf(stdout,"\n");
        }





	j_long hash = 4935908334937214722ULL; //6163373583986838439ULL; // tutu() : 3 integers args
	

	j_long calcHash = 0;
	calcHash = (((uint64)Message_Digest[7]&0x00000000000000ff) << 56) | (((uint64)Message_Digest[6]&0x00000000000000ff) << 48) | 
		   (((uint64)Message_Digest[5]&0x00000000000000ff) << 40) | (((uint64)Message_Digest[4]&0x00000000000000ff) << 32) | 
		   (((uint64)Message_Digest[3]&0x00000000000000ff) << 24) | (((uint64)Message_Digest[2]&0x00000000000000ff) << 16) |
		   (((uint64)Message_Digest[1]&0x00000000000000ff) << 8)  | ((uint64)Message_Digest[0]&0x00000000000000ff);
	fprintf(stdout, "\nHASH value = %lld ",hash);
	fprintf(stdout, "\nHASH Calc value = %lld ",calcHash);
*/


	writejLong(fd, calcHash);

	// Add Arguments
	writejInt(fd, (j_int)11111);
	//writejInt(fd, (j_int)11121);
	//writejInt(fd, (j_int)11131);
			
	// if I dont write a final zero-byte after the end of the stream (not required in specifications)
	// the last byte of the return value of the RMI call is not read from the return stream
	writejByte(fd, 0);
	

			j_byte x1;

			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);

parseObjectOutputStream(fd);		
			
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);


			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
		
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);

			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);

			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);



/*
j_int intReply1;
parsejInt(fd, &intReply1);
fprintf(stdout,"\nread INT=>%d",intReply1);
*/


			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
		
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			

			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
		
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);

			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
		
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);		
/*
			//Attention, On sait ici que le premier argument est un String
			//On doit le vrifier, le checker avec 
			//l'interface correspondant au hash code prcdent.
			//Attention ici on connait l'interface,
			//C'est l'interface du registry
			//On connait donc les mthodes associes et leurs signatures.
			
			if(objNum!=0)
			{
				fprintf(stdout,"Request to objNum %d\n",objNum);
				fprintf(stdout,"Not yet implemented \n");
				
				//Faudrait rcuprer le TC_ARRAY
				
				
				return;
			}
			
			
			 // Read the next Code in the Stream.
			
			//Parse directly the content of the next thing in the stream
			//That must be an object as described in the rmi specification
			//Dpend de l'interface Registry
			
			fprintf(stdout,"END !!!!\n");
			
		
			//normal Return
		
			
			
			fprintf(stdout,"Affiche le Stub\n");
*/			

	//	fflush(stdout);	


}

	





//////////////////////FROM INDISS :///////////////////////////////////



void *jrmp_run_composer(void* ptr)
{

	fprintf(stdout,"jrmp_run_composer: starts. \n");
	static int already_sent = 0;
	
	COMPOSETHREADDATA_PTR data = (COMPOSETHREADDATA_PTR)ptr;
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = (EVENTQUEUE_TABLE_ENTRY_PTR)data->entry_event_queue;
	COMPOSER_PTR composer = (COMPOSER_PTR)data->composer;
	
	pthread_mutex_lock(&(entry->mutex));
	
	
	// Add the identifier of the thread composer to the eventqueue_table 
	pthread_t thread_composer = pthread_self();
	
	//SSDPMSG_PTR ssdpmsg = ssdpmsg_create();
	
	fprintf(stdout,"jrmp_run_composer: starts. number of events=%d\n",entry->event_queue->size);
	
	//char* service_name;
	//char* method_name;
	//METHODDEFPTR method_to_call;
	
	SERVICE_COMM_TABLE services_table;
	service_comm_table_init(&services_table);
	
	
	while (1)
	{
		//fprintf(stdout,"ssdp_run_composer: starts. number of events=%d\n",entry->event_queue->size);
		
		EVENT_PTR evt = eventqueue_table_get_event(entry);
		if (evt != NULL)
		{
		fprintf(stdout,"jrmp_run_composer (phread=%p): evt is type=%d, src=%p\n", thread_composer, evt->type,evt->stream_id);
		event_print(evt);  
		
		switch (evt->type) 
		{
			case SDP_SOURCE_ADDR:
			//reply_dest_addr = strdup(evt->value.value_string);
			//slpmsg_set_dest_addr(slpmsg, reply_dest_addr);
			break;		
			case SDP_SOURCE_PORT:
			//reply_dest_port = evt->value.value_int;
			//slpmsg_set_dest_port(slpmsg, reply_dest_port);
			break;	
			
			case SDP_REQ_LANGAGE:
			//	slpmsg_set_lang_tag(slpmsg, evt->value.value_string);
			break;
			case SDP_REQ_SCOPE:
			//slpmsg_set_scope_list(slpmsg, evt->value.value_string);
			break;	
			case SDP_REQ_PREDICAT:
			//slpmsg_set_predicate(slpmsg, evt->value.value_string);
			break;	
			case SDP_REQ_REQUESTER:
			//slpmsg_set_pr_list(slpmsg, evt->value.value_string);
			break;	
			
			
			/*
			case SDP_REQ_SERVICE_TYPE:
			{
			char* st = malloc(strlen("urn:schemas-upnp-org:") + strlen("device:tv") + strlen(":1"));
			strncpy(st, "urn:schemas-upnp-org:", strlen("urn:schemas-upnp-org:"));
			
			//if (!strcmp(evt->value.value_string, "service:tv"))
			strncat(st, "device:tv", strlen("device:tv"));
			//else
			//	strncat(st, evt->value.value_string, strlen(evt->value.value_string));
			strncat(st, ":1", strlen(":1"));
			strncat(st, "\0" ,1);
			ssdpmsg_add_header(ssdpmsg, "ST", st);
			}
			break;	
			case SDP_REQ_ID:
			//slpmsg_set_xid(slpmsg, evt->value.value_int);
			break;		
			case SDP_VERSION:
			//slpmsg_set_version(slpmsg, evt->value.value_int);
			break;		
			*/	
			
			case SDP_SERVICE_DESCR_URL_NOPATH:
				if (!service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					service_comm_table_add_entry(&services_table, evt->stream_id);
				}
				service_comm_table_set_url_nopath(&services_table, evt->stream_id, evt->value.value_string);
				fprintf(stdout, "jrmp_run_composer: SDP_SERVICE_DESCR_URL_NOPATH: %s", evt->value.value_string);
				break;
			case SDP_SERVICE_DESCR_URL_PATH:
				if (!service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					service_comm_table_add_entry(&services_table, evt->stream_id);
				}
				service_comm_table_set_url_path(&services_table, evt->stream_id, evt->value.value_string);
				fprintf(stdout, "jrmp_run_composer: SDP_SERVICE_DESCR_URL_PATH: %s", evt->value.value_string);
				
				break;
				
			case SDP_STOP:	
			{
				if (service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					fprintf(stdout, "jrmp_run_composer: SDP_STOP\n");
					
					char* url_nopath = service_comm_table_get_url_nopath_by_stream_id(services_table, evt->stream_id);
					char* url_path = service_comm_table_get_url_path_by_stream_id(services_table, evt->stream_id);
					
					if (url_path[0] == '/')
						url_path = url_path + sizeof(char)*1;
					/*
					char* ip = "192.168.2.2";
					int port = 1099;	
					*/
					char *ip;
					int port;
					char* url;
					parseURL_host_port(url_nopath, &ip, &port, &url);
					
					fprintf(stdout, "jrmp_run_composer: SDP_STOP ip=%s port=%d url_path=%s\n",ip, port, url_path);
					/*
					long long  objNum;
					int	  objId;
					long long  objTime;         
					short	  objCount;
					int objPort;
					JMETHODS_PTR meths = create_JMethods();
					*/
					composeJRMP_lookup(ip, port, url_path, /*&objNum, &objId, &objTime, &objCount, &objPort, meths,  */
							evt->stream_id, (void*)evt->src, composer);
					
					fprintf(stdout, "jrmp_run_composer: FINISHED");
					
					
					composer_publish_event(event_create(SDP_START, evt->stream_id, /*parser*/(void*)evt->src), composer);	
					//	composer_publish_event(event_create(SDP_SLP, 1, /*parser*/(void*)0), composer);
				}
			}
			break;
			/*		
			if (!already_sent)
			{
			already_sent =1;
			ssdpmsg_set_method(ssdpmsg, "M-SEARCH");
			ssdpmsg_set_version(ssdpmsg, "HTTP/1.1");
			ssdpmsg_set_uri(ssdpmsg, "*");
			ssdpmsg_add_header(ssdpmsg, "HOST", "239.255.255.250:1900");
			ssdpmsg_add_header(ssdpmsg, "MX", "3");
			ssdpmsg_add_header(ssdpmsg, "MAN", "\"ssdp:discover\"");
			
			ssdpmsg_set_dest_addr(ssdpmsg, "239.255.255.250");
			ssdpmsg_set_dest_port(ssdpmsg, 1900);
			
			//ssdpmsg_set_dest_addr(ssdpmsg, "192.168.2.2");
			//ssdpmsg_set_dest_port(ssdpmsg, 38007);
			
			MSG_PTR msg = ssdpcomposer_ssdp_request(ssdpmsg);
			
			composer_publish_msg(msg, composer);
			
			}
			
			//pthread_mutex_lock(&(entry->mutex));
			
			fprintf(stdout, "ssdp_run_composer: (before remove) eventqueue_table_get_composer_thread_list_length(entry=%p) = %d\n",entry, eventqueue_table_get_composer_thread_list_length(entry));
			
			
			COMPOSERTHREAD_LIST_ENTRY_PTR first_composer_thread  = eventqueue_table_remove_first_composer_thread(entry);
			
			// set current_socket_reply_port for ssdp parser to find the right entry on the table
			entry->current_socket_reply_port = first_composer_thread->socket_reply_port;				
			
			pthread_cond_signal(&(first_composer_thread->cond));
			
			
			fprintf(stdout, "ssdp_run_composer: (after remove) eventqueue_table_get_composer_thread_list_length(entry=%p) = %d\n",entry, eventqueue_table_get_composer_thread_list_length(entry));
			
			
			pthread_mutex_unlock(&(entry->mutex));
			
			fprintf(stdout, "ssdp_run_composer: signal cond var %p\n", &(first_composer_thread->cond));
			return;
			}
			break;
			*/
			
			case SCP_SOAP:
				fprintf(stdout, "jrmp_run_composer: SCP_SOAP");
				break;
		
			case SCP_METHOD_NAME:
			{
				if (!service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					service_comm_table_add_entry(&services_table, evt->stream_id);
				}
				METHODDEFPTR m = service_comm_table_get_methoddef_by_stream_id(services_table, evt->stream_id);
				//method_name = strdup(evt->value.value_string);
				//method_to_call = methoddef_new2();
				methoddef_set_name(m, evt->value.value_string);	
				//service_comm_table_set_method(&services_table, evt->stream_id, method_to_call);
				fprintf(stdout, "jrmp_run_composer: SCP_METHOD_NAME");
			}
				break;
				
			case SCP_ARGUMENT_IN:
			{
				fprintf(stdout, "jrmp_run_composer: SCP_ARGUMENT_IN");
				if (!service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					service_comm_table_add_entry(&services_table, evt->stream_id);
				}
				METHODDEFPTR m = service_comm_table_get_methoddef_by_stream_id(services_table, evt->stream_id);
				//method_name = strdup(evt->value.value_string);
				//method_to_call = methoddef_new2();
				//methoddef_set_name(method_to_call, method_name);	
				//service_comm_table_set_method(&services_table, evt->stream_id, method_to_call);
				methoddef_add_argument(m, evt->value.value_void_pointer);
			}
				break;
				
			case SCP_ARGUMENT_OUT:
			{
				ARGUMENTDEFPTR arg = (ARGUMENTDEFPTR)evt->value.value_void_pointer;
				
				fprintf(stdout, "jrmp_run_composer: SCP_ARGUMENT_OUT");
				if (!service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					service_comm_table_add_entry(&services_table, evt->stream_id);
				}
				METHODDEFPTR m = service_comm_table_get_methoddef_by_stream_id(services_table, evt->stream_id);
				
				ARGUMENTDEFPTR args1_tmp = m->args;
	    		int found = 0;
	        	while (!found && args1_tmp != NULL)
	        	{
	        		if (args1_tmp->dir == ARG_OUT && (!strcmp(args1_tmp->name, arg->name)))
	        		{
	        			found = 1;
	        			if (args1_tmp->datatype == NULL)
	        				argumentdef_set_value(args1_tmp, (char*)arg->datatype);	
	        			if (args1_tmp->value == NULL)
	        				argumentdef_set_value(args1_tmp, (char*)arg->value);					        		
	        		}
	        		args1_tmp = args1_tmp->next;
	        	}
	        	if (!found)
	        		methoddef_add_argument(m, arg);
			}
				break;
				
			case SCP_RMI_STUB_OBJ:
			{
				fprintf(stdout, "jrmp_run_composer: SCP_RMI_STUB_OBJ");
				if (!service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					service_comm_table_add_entry(&services_table, evt->stream_id);
				}
				service_comm_table_add_rmiholder_stub(&services_table, evt->stream_id, (RMIHOLDER_STUB_OBJ_PTR)evt->value.value_void_pointer);
				
			}
				break;
				
            case SCP_SOCKET_ID:
            {
         	   fprintf(stdout, "jrmp_run_composer: SCP_SOCKET_ID value=%d\n",evt->value.value_int);
   				if (!service_comm_table_contains_stream_id(services_table, evt->stream_id))	
 				{
 					service_comm_table_add_entry(&services_table, evt->stream_id);
 				}
 				service_comm_table_set_src_socket_id(&services_table, evt->stream_id, evt->value.value_int);
            }
            break;
            
			case SCP_SERVICE_NAME:
				if (!service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					service_comm_table_add_entry(&services_table, evt->stream_id);
				}
				service_comm_table_set_service_name(&services_table, evt->stream_id, evt->value.value_string);
			//	service_name = strdup(evt->value.value_string); 
				fprintf(stdout, "SCP_SERVICE_NAME value = %s\n",evt->value.value_string);
				break;
				
			case SCP_SEND_SERVICE_REQUEST:
			{
				if (service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					fprintf(stdout, "jrmp_run_composer: service_comm_table_contains_stream_id");
					
					char* service_name = service_comm_table_get_service_name_by_stream_id(services_table, evt->stream_id);
					METHODDEFPTR method_to_call = service_comm_table_get_methoddef_by_stream_id(services_table, evt->stream_id);
					char* method_name = method_to_call->name;
					
				    //char* path4 = "/washer_rmislp.WasherImpl/control";
				    SERVICEDEFPTR srvTmp = Table_get_ServiceDef(ServiceDefinitionTable, service_name);
				    if (srvTmp != NULL)
				    {
				    	fprintf(stdout,"\nService %s Found: %s\n",service_name, srvTmp->name);
				    	
				    	
				    	METHODDEFPTR method_from_servicedef = servicedef_getmethod_byname(srvTmp, method_name);
				    	/*
				    	srvTmp->RMI_ObjPort = 36781;
				        
				    	srvTmp->RMI_ObjNum = 0;
				    	srvTmp->RMI_ObjUnique = 32635808;
				    	srvTmp->RMI_ObjTime = 1156511820115; //1165617491; // 481482311; //1155827684935;
				    	srvTmp->RMI_ObjCount = -32768;
				        */
				    	servicedef_print(srvTmp);
				    	
				    	fprintf(stdout,"\nmethod_to_call :\n"); 
				    	methoddef_print(method_to_call);
				    	
				    	if (method_from_servicedef != NULL)
				    	{
					    	// if datatype is not set for the arguments of the method to call, fill the value
					    	// of these fields from method_from_servicedef
					    	ARGUMENTDEFPTR args1_tmp = method_to_call->args;
					        while (args1_tmp != NULL)
					        {
					        	if (args1_tmp->datatype == NULL)
					        	{
							    	ARGUMENTDEFPTR args2_tmp = method_from_servicedef->args;
							    	int found = 0;
							        while (args2_tmp != NULL && !found)
							        {
					        			if (strcmp(args1_tmp->name, args2_tmp->name) == 0)
					        			{
					        				args1_tmp->datatype = strdup(args2_tmp->datatype);
					        				found = 1;
					        			}
					        			args2_tmp = args2_tmp->next;
							        }
					        	}
					        	args1_tmp = args1_tmp->next;
					        }
					        
					    	
					    	
					    	// modify evt->src value to (this jrmp composer + its rmi unit)
					    	((EVENTSRC_PTR)evt->src)->src_thread_parser = (void*)thread_composer;
					    	((EVENTSRC_PTR)evt->src)->src_unit = composer->unit;
					    	
					    	
					    	composeJRMP_Call(srvTmp->host , srvTmp->RMI_ObjPort, srvTmp, /* method_from_servicedef, */ method_to_call,
					    			evt->stream_id, (void*)evt->src, composer);
					    	
							// TEST: try to modify the value of BooleanHolder on the RMI Client
							//composeJRMP_Call_on_RMIObject(obj);
							//sendVoid(fd); 
				    	}
				    	else
				    	{
				    		fprintf(stdout,"\nMethod %s NOT Found\n", method_name);
				    	}
				    	
				    	

				    }
				    else
				    	fprintf(stdout,"\nService %s NOT Found\n", service_name);
				}
			}	
			break;
				
			case SCP_SEND_SERVICE_REPLY:
			{
				fprintf(stdout, "\n________________________-jrmp_run_composer: SCP_SEND_SERVICE_REPLY__________________\n");
				if (service_comm_table_contains_stream_id(services_table, evt->stream_id))	
				{
					METHODDEFPTR method_to_reply = service_comm_table_get_methoddef_by_stream_id(services_table, evt->stream_id);
					methoddef_print(method_to_reply);
					
					RMIHOLDER_STUB_OBJ_PTR tmp = service_comm_table_get_rmiholder_objs_by_stream_id(services_table, evt->stream_id);
					while (tmp != NULL)
					{
						fprintf(stdout, "\n tmp->arg_index = %d \n", tmp->arg_index);
						
				    	ARGUMENTDEFPTR args1_tmp = method_to_reply->args;
				    	int found = 0;
				        while (!found && args1_tmp != NULL)
				        {
				        	if (args1_tmp->index == tmp->arg_index)
				        	{
				        		found = 1;
				        		composeJRMP_Call_on_RMIObject(tmp->obj, args1_tmp);
				        	}
				        	args1_tmp = args1_tmp->next;
				        }
						tmp = tmp->next;
					}
				}
				int fd = service_comm_table_get_src_socket_id_by_stream_id(services_table, evt->stream_id);
				fprintf(stdout, "\n________________________-jrmp_run_composer: SCP_SEND_SERVICE_REPLY fd=%d__________________\n",fd);
				sendVoid(fd); 
				writejByte(fd, 0);
				int test = close(fd);
				fprintf(stdout,"ParseJRMP finished. close = %d\n",test);
			}
				break;
			}	
			

		}
		usleep(10);
	
	
	
	
	//else
	//	fprintf(stdout,"slp_run_composer: NO evt !\n"); 
	}
}

void jrmp_composer_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout,"JRMP");
	composer_event_received(evt, node);
}


COMPOSER_PTR jrmp_composer_create(UNIT_PTR u)
{
	fprintf(stdout, "Creting JRMP composer\n");
	
	
	COMPOSER_PTR c = composer_create(u);
	
	c->run_composer = jrmp_run_composer;
	c->factory = jrmp_composer_create;
	
	c->func_event_received = jrmp_composer_event_received;	
	return c;	
}


void service_comm_table_init(SERVICE_COMM_TABLE* table)
{
	table->n_services = 0;
	int i =0;
	for (i=0 ; i<100; i++)
	{
		table->services[i].stream_id = -1;
		int stream_id;
		table->services[i].service_name = NULL;
		table->services[i].method = NULL;
		table->services[i].source_addr = NULL;
		table->services[i].source_port = -1;
		table->services[i].url_path = NULL;
		table->services[i].url_nopath = NULL;
		table->services[i].src_socket_id = -1;
		table->services[i].rmiholder_objs = NULL;
	}
}

void service_comm_table_add_entry(SERVICE_COMM_TABLE* table, int stream_id)
{
	fprintf(stdout, "service_comm_table_add_entry(table->n_services=%d). stream_id=%p \n",table->n_services, stream_id);
	
	table->services[table->n_services].stream_id = stream_id;
	table->services[table->n_services].method = methoddef_new2();
	table->n_services += 1;
	
	fprintf(stdout, "service_comm_table_add_entry END (table->n_services=%d). stream_id=%p \n",table->n_services, stream_id);
}

int service_comm_table_contains_stream_id(SERVICE_COMM_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "service_comm_table_contains_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return 1;
	}
	return 0;
}

void service_comm_table_set_url_nopath(SERVICE_COMM_TABLE* table, int stream_id, char* url_nopath)
{
	int i =0;
	for (i=0 ; i<table->n_services; i++)
	{
		fprintf(stdout, "service_comm_table_set_url_nopath. (nservices=%d) str1=%p str2=%p location_url_path=%s\n",table->n_services, table->services[i].stream_id, stream_id, url_nopath);
		if (table->services[i].stream_id == stream_id)
		{
			table->services[i].url_nopath = strdup(url_nopath);
			//fprintf(stdout, "table.services[i].location_url_path set to : %s location_url_path=%s\n",table->services[i].location_url_nopath,url_nopath);
		}
	}
}

void service_comm_table_set_url_path(SERVICE_COMM_TABLE* table, int stream_id, char* url_path)
{
	int i =0;
	for (i=0 ; i<table->n_services; i++)
	{
		fprintf(stdout, "service_comm_table_set_url_path. (nservices=%d) str1=%p str2=%p location_url_path=%s\n",table->n_services, table->services[i].stream_id, stream_id, url_path);
		if (table->services[i].stream_id == stream_id)
		{
			table->services[i].url_path  = strdup(url_path);
			//fprintf(stdout, "table.services[i].location_url_path set to : %s location_url_path=%s\n",table->services[i].location_url_path, url_path);
		}
	}
}

void service_comm_table_set_service_name(SERVICE_COMM_TABLE* table, int stream_id, char* service_name)
{
	int i =0;
	for (i=0 ; i<table->n_services; i++)
	{
		fprintf(stdout, "service_comm_table_set_service_name. (nservices=%d) str1=%p str2=%p location_url_path=%s\n",table->n_services, table->services[i].stream_id, stream_id, service_name);
		if (table->services[i].stream_id == stream_id)
		{
			table->services[i].service_name  = strdup(service_name);
			//fprintf(stdout, "table.services[i].service_name set to : %s location_url_path=%s\n",table->services[i].location_url_path, service_name);
		}
	}
}

void service_comm_table_set_method(SERVICE_COMM_TABLE* table, int stream_id, METHODDEFPTR method)
{
	int i =0;
	for (i=0 ; i<table->n_services; i++)
	{
		fprintf(stdout, "service_comm_table_set_method. (nservices=%d) str1=%p str2=%p location_url_path=%s\n",table->n_services, table->services[i].stream_id, stream_id);
		if (table->services[i].stream_id == stream_id)
		{
			table->services[i].method  = method;
			//fprintf(stdout, "table.services[i].method set to : %s location_url_path=%s\n",table->services[i].location_url_path, service_name);
		}
	}
}

void service_comm_table_set_source_addr(SERVICE_COMM_TABLE* table, int stream_id, char* source_addr)
{
	int i =0;
	for (i=0 ; i<table->n_services; i++)
	{
		fprintf(stdout, "service_comm_table_set_soruce_addr. (nservices=%d) str1=%p str2=%p location_url_path=%s\n",table->n_services, table->services[i].stream_id, stream_id, source_addr);
		if (table->services[i].stream_id == stream_id)
		{
			table->services[i].source_addr  = strdup(source_addr);
			//fprintf(stdout, "table.services[i].soruce_addr set to : %s location_url_path=%s\n",table->services[i].location_url_path, source_addr);
		}
	}
}

void service_comm_table_set_source_port(SERVICE_COMM_TABLE* table, int stream_id, int source_port)
{
	int i =0;
	for (i=0 ; i<table->n_services; i++)
	{
		//fprintf(stdout, "service_comm_table_set_source_port. (nservices=%d) str1=%p str2=%p source_port=%d\n",table->n_services, table->services[i].stream_id, stream_id, soruce_addr);
		if (table->services[i].stream_id == stream_id)
		{
			table->services[i].source_port = source_port;
			fprintf(stdout, "table.services[i].source_port set to : %d source_port=%d\n",table->services[i].source_port, source_port);
		}
	}
}

char* service_comm_table_get_service_name_by_stream_id(SERVICE_COMM_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "service_comm_table_get_service_name_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].service_name;
	}
	return NULL;
}

METHODDEFPTR service_comm_table_get_methoddef_by_stream_id(SERVICE_COMM_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "service_comm_table_get_methoddef_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].method;
	}
	return NULL;
}

char* service_comm_table_get_url_path_by_stream_id(SERVICE_COMM_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "service_comm_table_get_url_path_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].url_path;
	}
	return NULL;
}

char* service_comm_table_get_url_nopath_by_stream_id(SERVICE_COMM_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "service_comm_table_get_url_nopath_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].url_nopath;
	}
	return NULL;
}

char* service_comm_table_get_source_addr_by_stream_id(SERVICE_COMM_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "service_comm_table_get_source_addr_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].source_addr;
	}
	return NULL;
}

int service_comm_table_get_source_port_by_stream_id(SERVICE_COMM_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "service_comm_table_get_source_port_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].source_port;
	}
	return -1;
}

int service_comm_table_get_src_socket_id_by_stream_id(SERVICE_COMM_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "service_comm_table_get_source_port_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].src_socket_id;
	}
	return -1;
}

void service_comm_table_set_src_socket_id(SERVICE_COMM_TABLE* table, int stream_id, int src_socket_id)
{
	int i =0;
	for (i=0 ; i<table->n_services; i++)
	{
		//fprintf(stdout, "service_comm_table_set_source_port. (nservices=%d) str1=%p str2=%p source_port=%d\n",table->n_services, table->services[i].stream_id, stream_id, soruce_addr);
		if (table->services[i].stream_id == stream_id)
		{
			table->services[i].src_socket_id = src_socket_id;
			fprintf(stdout, "table.services[i].src_socket_id set to : %d src_socket_id=%d\n",table->services[i].src_socket_id, src_socket_id);
		}
	}
}

void service_comm_table_add_rmiholder_stub(SERVICE_COMM_TABLE* table, int stream_id, RMIHOLDER_STUB_OBJ_PTR obj)
{
	int i =0;
	for (i=0 ; i<table->n_services; i++)
	{
		fprintf(stdout, "service_comm_table_set_rmiholder_stub. (nservices=%d) \n",table->n_services);
		if (table->services[i].stream_id == stream_id)
		{
			if (table->services[i].rmiholder_objs == NULL)
			{
				obj->next = NULL;
				table->services[i].rmiholder_objs = obj;
			}
			else
			{
				obj->next = table->services[i].rmiholder_objs;
				table->services[i].rmiholder_objs = obj;
			}
			//fprintf(stdout, "table.services[i].method set to : %s location_url_path=%s\n",table->services[i].location_url_path, service_name);
		}
	}
}

RMIHOLDER_STUB_OBJ_PTR service_comm_table_get_rmiholder_objs_by_stream_id(SERVICE_COMM_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "service_comm_table_get_rmiholder_objs_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].rmiholder_objs;
	}
	return NULL;
}
