#include "engine/action.h"
#include <stdio.h>

ACTION_PTR action_create_function1(char* name, prototype_function1 function/*, char* arguments*/)
{
	ACTION_PTR action = malloc(sizeof(ACTION));
	action->name = strdup(name);
	action->type = 1;
	action->function.function1 = function;
	//action->arguments = strdup(arguments);
	action->next_action = NULL;
	return action;
}

ACTION_PTR action_create_function2(char* name, prototype_function2 function /*, char* arguments*/)
{
	ACTION_PTR action = malloc(sizeof(ACTION));
	action->name = strdup(name);
	action->type = 2;
	action->function.function2 = function;
	//action->arguments = strdup(arguments);
	action->next_action = NULL;
	return action;
}


ACTION_PTR action_create_function3(char* name, prototype_function3 function)
{
	ACTION_PTR action = malloc(sizeof(ACTION));
	action->name = strdup(name);
	action->type = 3;
	action->function.function3 = function;
	action->next_action = NULL;
	return action;
}

ACTION_PTR action_create_function4(char* name, prototype_function4 function)
{
	ACTION_PTR action = malloc(sizeof(ACTION));
	action->name = strdup(name);
	action->type = 4;
	action->function.function4 = function;
	action->next_action = NULL;
	return action;
}

ACTION_PTR action_create_function5(char* name, prototype_function5 function)
{
	ACTION_PTR action = malloc(sizeof(ACTION));
	action->name = strdup(name);
	action->type = 5;
	action->function.function5 = function;
	action->next_action = NULL;
	return action;
}

ACTION_PTR action_create_function6(char* name, prototype_function6 function)
{
	ACTION_PTR action = malloc(sizeof(ACTION));
	action->name = strdup(name);
	action->type = 6;
	action->function.function6 = function;
	action->next_action = NULL;
	return action;
}

ACTION * action_get_byname(ACTION* actions, char* function_name)
{
	ACTION* tmp ;
	for (tmp = actions; tmp != NULL; tmp = tmp->next_action)
	{
		if (strcmp(tmp->name, function_name) == 0)
		{
			ACTION * Action;
			switch (tmp->type)
			{
			   case 1:
				   Action = action_create_function1(function_name, tmp->function.function1);
				   break;
			   case 2:
				   Action = action_create_function2(function_name, tmp->function.function2);
				   break;
			   case 3:
				   Action = action_create_function3(function_name, tmp->function.function3);
				   break;
			   case 4:
				   Action = action_create_function4(function_name, tmp->function.function4);
				   break;
			   case 5:
				   Action = action_create_function5(function_name, tmp->function.function5);
				   break;
			   case 6:
				   Action = action_create_function6(function_name, tmp->function.function6);
				   break;
			   default:
				   return NULL;
			}
			return Action;
		}
	}
	return NULL;
}



