#include <stdio.h>
#include <stdlib.h>
#include "engine.h"


int main(int argc, char *argv[]) {


	FILE *fp;
	int i;
	//GRAPH * graph ;// = malloc(sizeof(GRAPH));
	
	fp = fopen(argv[1], "r");
	if(fp == NULL) {
		fprintf(stderr, "cat: can't open %s\n", argv[1]);
		exit(0);
	}
	
	ACTION_PTR action =  action_create_function1("print", print);
	
	ENGINE * engine = engineCreate(fp,action,NULL);
	
	

	//Partie de test des evenements
	EVENT * sdp_start = malloc (sizeof(EVENT));
	EVENT * sdp_stop = malloc (sizeof(EVENT));
	EVENT * sdp_slp = malloc (sizeof(EVENT));
	EVENT * sdp_upnp = malloc (sizeof(EVENT));
	EVENT * sdp_request = malloc (sizeof(EVENT));
	EVENT * sdp_service_alive = malloc (sizeof(EVENT));
	
	sdp_start->type=90;
	sdp_stop->type=94;
	sdp_slp->type=93;
	sdp_upnp->type=91;
	sdp_request->type=101;
	sdp_service_alive->type=102;
	
	
	
	EVENT * eventstab1[7];
	eventstab1[0]=sdp_stop;
	eventstab1[1]=sdp_start;
	eventstab1[2]=sdp_slp;
	eventstab1[3]=sdp_slp;
	eventstab1[4]=sdp_request;
	eventstab1[5]=sdp_upnp;
	eventstab1[6]=sdp_stop;
	

	//initEngine("IDLE");
	
	
	for(i=0;i<7;i++) {
		eventstab1[i]->src=1;
		engineDispatchEvent(engine,eventstab1[i]);
	}
	fclose(fp);
	return 0;

}










/*
	FILE *fp;
	//GRAPH * graph ;// = malloc(sizeof(GRAPH));
	PARSERESULT * parseresult;
	int i;

	fp = fopen(argv[1], "r");
	if(fp == NULL) {
		fprintf(stderr, "cat: can't open %s\n", argv[1]);
	}
		
	parseresult=parse(fp);
	
	graph=parseresult->graph;
	events=parseresult->events;
	nb_events=parseresult->nb_events;
	
	//for(i=0;i<nb_events;i++)
	//	printf("%s == %i \n\n",events[i].name,(events[i].sdpevent)->type);
	
	printf("apres parsage \n");
	//printGraph(graph);
	

	//Partie de test des evenements
	EVENT * sdp_start = malloc (sizeof(EVENT));
	EVENT * sdp_stop = malloc (sizeof(EVENT));
	EVENT * sdp_slp = malloc (sizeof(EVENT));
	EVENT * sdp_upnp = malloc (sizeof(EVENT));
	EVENT * sdp_request = malloc (sizeof(EVENT));
	EVENT * sdp_service_alive = malloc (sizeof(EVENT));
	
	sdp_start->type=90;
	sdp_stop->type=94;
	sdp_slp->type=93;
	sdp_upnp->type=91;
	sdp_request->type=101;
	sdp_service_alive->type=102;
	
	
	
	EVENT * eventstab1[7];
	eventstab1[0]=sdp_stop;
	eventstab1[1]=sdp_start;
	eventstab1[2]=sdp_slp;
	eventstab1[3]=sdp_slp;
	eventstab1[4]=sdp_request;
	eventstab1[5]=sdp_upnp;
	eventstab1[6]=sdp_stop;
	
	
	

	initEngine("IDLE");
	EVENT * sdpevent = malloc (sizeof(EVENT));
	sdpevent->type=42;
	
	//engine(sdpevent);
	
	//engine(sdp_upnp);
	
	for(i=0;i<7;i++)
		engineDispatchEvent(eventstab1[i]);

	fclose(fp);
	return 0;
	*/

