/*
 * 
 *             Author  @Youssef Laarouchi : laarouchi_yous@yahoo.fr
 * 
 * 
 */
 
 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <regex.h>

#include "engine/parser.h"


void print (char * s) {
	
	//printf("chaine retourne = %s \n",s);

}


int isBlanck(char * s) {
	
	char c;
	int test=1;
	while(((c=s[0])!='\0') && (test)){
		if((c!=' ') && (c!='\n') && (c!='\r') && (c!='\t'))
				test=0;  
		s++;
	}
	return test;
}

char* noBlanck(char *s) {

	char * cs=malloc(sizeof(char)*(strlen(s)+1));
	int i;
	int j=0;
	for(i=0;i<=strlen(s);i++){
		if(s[i]!=' ')
			cs[j++]=s[i];
	//printf("chaine de retour #%s# \n",cs);
	}
	return cs;	
}
	







EVENTDEF * getEvents(char *  unparsed_decs, EVENTDEF * events, int* nb_defined_events)   {
	
	//printf("je vais parser les declarations suivantes %s \n",unparsed_decs);
	
	
	*nb_defined_events=0;
	int i = 0;
	char ** result = malloc (sizeof(char*)*2);
	
	while(!isBlanck(unparsed_decs)){
		
		(*nb_defined_events)++;
		events = (EVENTDEF *)realloc(events, sizeof(EVENTDEF)*(*nb_defined_events));
		if(events==NULL) 
		{
			//printf("Error (re)allocating memory \n"); 
			exit (1); 
		}
		
		
		result = getBetweenTokens(unparsed_decs,'#','#');
		events[i].name=result[1];
		
		(EVENT *) events[i].sdpevent = (EVENT *) malloc (sizeof(EVENT)); 
		result = getBetweenTokens(unparsed_decs,'/','/');
		(events[i].sdpevent)->type=atoi(result[1]);
		
		//printf("%s == %i \n\n",events[i].name,atoi(result[1]));
	
		//printf("i==%d nb...=%d %s == %i \n\n",i,(*nb_defined_events),events[i].name,(events[i].sdpevent)->type);
		unparsed_decs=result[0];
		
		i++;
		
	}
	
	return events;
	/*
	 while(!isBlanck(unparsed_decs)){
		
		//realloc(events, sizeof(*events)*(nb_events+1));
		
		result = getBetweenTokens(unparsed_decs,'#','#');
		events[i].name=result[1];
		
		(EVENT *) events[i].sdpevent = (EVENT *) malloc (sizeof(EVENT)); 
		result = getBetweenTokens(unparsed_decs,'/','/');
		(events[i].sdpevent)->type=atoi(result[1]);
		
		//printf("%s == %i \n\n",events[i].name,atoi(result[1]));
	
		printf("%s == %i \n\n",events[i].name,(events[i].sdpevent)->type);
		unparsed_decs=result[0];
		(*nb_defined_events)++;
		i++;
		
	}
	*/
	
}




void updateGraph(GRAPH * original_graph, STATE * state) {

	//realloc (original_graph, sizeof(*original_graph)*(2));
	//GRAPH * graph;//= malloc(sizeof(GRAPH));
	
	//graph=original_graph;
	
	//graph= malloc(sizeof(*graph));
	//graph=realloc(graph,sizeof(*graph)*2);
	
	TRANSITION *transition;// = (TRANSITION*) malloc(sizeof(TRANSITION));
	
	
	
	//printf("size of obtained state == %d \n",sizeof(state));
	//printf("name of obtained state == %s \n",state->name);
	
	
	NODE *node1,*node2;
	
	if (original_graph==NULL) 
		printf("graphe null\n");

	node1 = add_node(original_graph, state->name,state->entry);

	transition=state->transition;

	while(transition !=NULL) {

		if(strcmp(transition->next_state,"nil")==0) {
			add_arc(node1,node1,transition->filter,transition->Action);
			//printf("added new arc %s : %s \n",transition->filter,transition->action);
			//printf("added new arc %s  \n",transition->filter);
			
		} else {
			//printf("added new node %s & new arc %s : %s \n",
			//	transition->next_state,transition->filter,transition->action);
			//printf("added new node %s & new arc %s  \n",
			//	transition->next_state,transition->filter);	
			node2 = add_node(original_graph, transition->next_state,NULL);
			add_arc(node1,node2,transition->filter,transition->Action);
			
		}	

		//printf("ARC DE DEPART CONTIENT %s:%s \n",node1->arcs->filter,node1->arcs->actions);
		transition=transition->next_transition;
	}
	printGraph(original_graph);
	//printf("GRAPH Updated\n");

	

	//return graph;	

}




/*
GRAPH * updateGraph(GRAPH * original_graph, STATE * state) {


	//realloc (original_graph, sizeof(*original_graph)*(2));
	GRAPH * graph;//= malloc(sizeof(GRAPH));
	
	graph=original_graph;
	
	graph= malloc(sizeof(*graph));
	//graph=realloc(graph,sizeof(*graph)*2);
	
	TRANSITION *transition;// = (TRANSITION*) malloc(sizeof(TRANSITION));
	
	
	
	printf("size of obtained state == %d \n",sizeof(state));
	printf("name of obtained state == %s \n",state->name);
	
	
	NODE *node1,*node2;
	
	if (graph==NULL) 
		printf("graphe null\n");
	
	
	node1 = add_node(graph, state->name);
	
	transition=state->transition;
	
	printf("name of obtained state 0202 == %s \n",state->name);
	
	while(transition !=NULL) {
		
		if(strcmp(transition->next_state,"nil")==0) {	
			add_arc(node1,node1,transition->filter,transition->Action);
			//printf("added new arc %s : %s \n",transition->filter,transition->action);
			printf("added new arc %s  \n",transition->filter);
			
		} else {
			//printf("added new node %s & new arc %s : %s \n",
			//	transition->next_state,transition->filter,transition->action);
			printf("added new node %s & new arc %s  \n",
				transition->next_state,transition->filter);	
			node2 = add_node(graph, transition->next_state);
			add_arc(node1,node2,transition->filter,transition->Action);
			
		}	
		//printf("ARC DE DEPART CONTIENT %s:%s \n",node1->arcs->filter,node1->arcs->actions);
		transition=transition->next_transition;
	}

	return graph;	

}
*/


	


//return the unparsed stream and the parsed one.
char ** getBetweenTokens(char * unparsed_state, char token1, char token2) {

	char c;
	int i=0;
	char ** result = malloc (sizeof(char*)*2);
	
	//printf("In getBetweenBrackets function token1=%c token2=%c\n",token1, token2);
	//printf("texte  parser 00 = %s\n",unparsed_state);	
	
	//The entry is defined between the two next brackets
	while(unparsed_state[0]!=token1) {
		unparsed_state++;
	}
	unparsed_state++;
	
	//Loop to caluculate the necessary memory size for the string
	while ( (c=unparsed_state[i++]) != token2);
	
	char *cs = (char*)malloc ((i+1)*sizeof(char));
	i=0;
	
	//obtaining the name	
	while ( (c=unparsed_state[0]) != token2){
		cs[i++]=c;	
		unparsed_state++;		
	}
	cs[i]='\0';
	unparsed_state++;
	
	//printf("Returned  Body = %s\n",cs);
	//printf("ramaining unparsed part = %s\n",unparsed_state);	
	result[0]=unparsed_state;
	result[1]=cs;
	return result;
}


char ** getBeforeToken(char * text, char token) {
	
	
	char c;
	int i=0;
	char ** result = malloc (sizeof(char*)*2);
	
	//printf("GETBEFORETOKEN  = %s\n",text);	
	
	
	
	//Loop to caluculate the necessary memory size for the string
	while ( (c=text[i++]) != token)
		if(c=='\0')
			break;
	
	//printf("i == %d\n",i);	
	char *cs = malloc((i+1)*sizeof(char));
	i=0;
	
	//printf("GETBEFORETOKEN  02\n");	
	//obtaining the name	
	while ( (c=text[0]) != token){
		cs[i++]=c;	
		text++;		
		if(strlen(text)==0)
			break;
		//printf("longueur == %d \n",strlen(text));
	}
	text++;
	
	//printf("Returned  Body = %s\n",cs);
	//printf("ramaining unparsed part = %s\n",unparsed_state);	
	
	
	result[0]=text;
	result[1]=cs;
	
	//printf("part 1 == |%s| les reste est == |%s| \n",result[1],result[0]);
	return result;
	
}

char ** parseArguments(char * arguments) {

	int nb_args;
	int i=0;
	char ** res;// = malloc (sizeof(char*)* 2);
	
	char c;
	
	
	if (arguments==NULL) {
		nb_args=0;
		return NULL;
	} else
		nb_args=1;
	
	
	
	while ( (c=arguments[i++])!='\0')
		if(c==',')
			nb_args++;
	
	//printf(" NBARGS == %d \n",nb_args);		
	char ** result = malloc (sizeof(char*)* nb_args);
	
	i=0;
	
	res=getBeforeToken(arguments,',');
	result[i++]=res[1];
	arguments=noBlanck(res[0]);
	
	while(strlen(arguments)!=0) {
		
		res=getBeforeToken(arguments,',');
		//printf("arg == %s reste == %s \n",res[1],res[0]);
		result[i++]=res[1];
		arguments=noBlanck(res[0]);
		//printf("strlen== %d \n",strlen(arguments));
	}
		
	return result;	
}



ACTION* parseAction(char * unparsed_action, ACTION* actions) {

	
	char * function_name = malloc(sizeof(char)*strlen(unparsed_action));
	//ACTION * Action=NULL;
	
	int i = 0;
	char c;
	
	//printf("\n UNPARSED ACTION == %s \n",unparsed_action);
	
	if(strcmp(unparsed_action,"")==0) 
		return NULL;
	
	while((c=unparsed_action[0])!='(') {
		if((c!=' ') && (c!='\n') && (c!='\r') && (c!='\t'))
			function_name[i++]=unparsed_action[0];
		unparsed_action++;
	}
	
	function_name[i]='\0';
	
	//printf("\n UNPARSED ACTION == %s \n",unparsed_action);
		
	char ** result = getBetweenTokens(unparsed_action,'(',')');
	
	//printf("function name  ==  |%s|    ", function_name);
	//printf("obtained arg == %s    ", result[1]);
	//printf("Still in actions == %s   \n", result[0]);
	
	ACTION * Action = action_get_byname(actions, function_name);
	//Action->arguments=result[1];
	Action->arguments=parseArguments(result[1]);
	
	
	//printf("arguments added %s \n",Action->arguments[0]);
	
	if (isBlanck(result[0])) {
		//printf("NO MORE ACTIONS TO TREAT\n");
		Action->next_action=NULL;
	} else {
		//printf("THERE ARE MORE ACTIONS TO TREAT\n");
		Action->next_action = parseAction(result[0], actions);
	}
	
	return Action;
	
}



TRANSITION * parseTransition(char * unparsed_transition, ACTION* actions) {

	TRANSITION * parsed_transition = (TRANSITION *) malloc (sizeof(*parsed_transition));
	(ACTION *) parsed_transition->Action = (ACTION *) malloc (sizeof(ACTION));
	
	
	//parsed_transition->next_transition=NULL;
	
	char ** result = malloc (sizeof(char*)*2);
	
	//First we obtain the filter
	result=getBetweenTokens(unparsed_transition,'[',']');
	parsed_transition->filter=noBlanck(result[1]);
	unparsed_transition=result[0];
	
	
	//Then the next state 
	result=getBetweenTokens(unparsed_transition,'[',']');
	parsed_transition->next_state=noBlanck(result[1]);
	unparsed_transition=noBlanck(result[0]);
	
	//Then the actions
	result=getBetweenTokens(unparsed_transition,'[',']');
	
	//parsed_transition->action=result[1];
	
	// *****************************************
	parsed_transition->Action=parseAction(noBlanck(result[1]), actions);
	
	
	
	ACTION * action;
	
	for(action=parsed_transition->Action;action!=NULL;action=action->next_action) {
		//printf ("ACTION EN COURS %s \n\n",action->name);
	}
	
	unparsed_transition=result[0];
	
	//parseAction(parsed_transition);
	
	//unparsed_transition
	//printf("\nla partie restante est\n%s...",unparsed_transition);
	
	if(!isBlanck(unparsed_transition)) {
		//printf("Il y a encore des transitions \n");
		parsed_transition->next_transition=parseTransition(unparsed_transition, actions);	
	} else {
		//printf("Toutes les transitions ont t traites \n");
		parsed_transition->next_transition=NULL;
	}
	//parsed_transition->next_state=getNextStateName(unparsed_transition);
	//parsed_transition->action=getActions(unparsed_transition);
	
	
	return parsed_transition;
	
}


STATE * parseState (char *unparsed_state, ACTION* actions) {
	
	//printf ("length to parse = %i\n",strlen(unparsed_state));
		
	//printf("going to parse = %s\n",unparsed_state);
	
		
	STATE * parsed_state = (STATE *) malloc(sizeof(STATE));
		

	char * * result=getBetweenTokens(unparsed_state,'{','}');
	
	char * unparsed_transition;
		
	parsed_state->name=noBlanck(result[1]);
	unparsed_state=noBlanck(result[0]);
	
	
	//printf("NAME  == %s \n",parsed_state->name);

	result=getBetweenTokens(unparsed_state,'{','}');

	
	//printf("ENTRY 00  == |%s| length == %d\n",result[1],strlen(result[1]));
	
	if(strlen(result[1])==0)
		parsed_state->entry=NULL;
	else 
		parsed_state->entry=parseAction(result[1],actions);
	
	
	unparsed_state=noBlanck(result[0]);
	
	result=getBetweenTokens(unparsed_state,'{','}');	
	unparsed_transition=noBlanck(result[1]);
	
	
	
	parsed_state->transition=parseTransition(unparsed_transition, actions);
	
	
	
	
	//printf("TRANSITION->NEXT_STATE  == %s \n",parsed_state->transition->next_state);
	//printf("TRANSITION->NEXT_TRANSITION->NEXT_STATE  == %s \n",parsed_state->transition->next_transition->next_state);
	
	
	//printf("End parse state \n");
	
	
	return parsed_state;

}




//PARSERESULT * parse (FILE *fp, ACTION* actions) {
PARSERESULT * parse (int fp, ACTION* actions) {
	
	//printf("In PARSE function \n ");
	char c;
	int i=0;
	int count=0;
	int count2=0;
	int nb_defined_events;
	
	GRAPH * graph=malloc(sizeof(GRAPH));
	graph->nodes = NULL;
	graph->n_nodes = 0;
		
	PARSERESULT * parseresult = (PARSERESULT *)  malloc (sizeof(PARSERESULT));
		
	
	//events is dynamically aallocated in getEvents function
	EVENTDEF * events = malloc(sizeof(EVENTDEF));
	
	
	char * unparsed_text = NULL;
	
	
	ssize_t nread;
	
	
	//while((c=getc(fp))!= EOF) {
	while((nread = read(fp, &c, 1)) == 1) {
		

		//realloc (unparsed_text, sizeof(*unparsed_text)*(i+1));
		if(c == '{' || c == '}')
			count++;

		if(c == '%') 
			count2++;
		else {
			/*
			realloc (unparsed_text, sizeof(char*)*(i+1));
			unparsed_text[i++]=c;*/
			unparsed_text = (char*)realloc (unparsed_text, sizeof(char)*(i+1));
			unparsed_text[i++]=c;
		}
		
		//state definition elements are between brackets
		/*if(c == '{' || c == '}')
			count++;
		*/
		
		
		//specifications are in the description file header and are between % %	
		if(count2==2) {

			unparsed_text[i]='\0';
			//printf("Declaration  parser %s \n",unparsed_text);
			events=getEvents(unparsed_text,events,&nb_defined_events);
			//printf("j'ai reconnu toutes les spcifications \n");
			//unparsed_text = malloc (sizeof(char));
			//free(unparsed_text);
			unparsed_text =NULL;
			count2=0;
			i=0;
		}

		if(count==6) {

			unparsed_text = (char*)realloc (unparsed_text, sizeof(char)*(i+1));
			unparsed_text[i]='\0';

			//printf("i==%d and strlen(unparsed_text)==%d\n",i,strlen(unparsed_text));
			
			updateGraph(graph, parseState(unparsed_text, actions));

			//unparsed_text = malloc (sizeof(char));
			unparsed_text = NULL;
			//free(unparsed_text);
			count=0;
			i=0;
			//printf("j'ai reconnu un etat\n");
		}

	}

//printf("END of parsing00 \n");
//printf("nb_defined_events == %d\n",nb_defined_events);

//printf("%s\n\n",events[1].name);

/*
for(i=0;i<nb_defined_events;i++)
	printf("i = %d   %s == %i \n\n",i,events[i].name,(events[i].sdpevent)->type);
*/

	
//printf("END of parsing 0\n");

parseresult->events=events;
//printf("END of parsing 1\n");
parseresult->graph=graph;
//printf("END of parsing 2\n");
parseresult->nb_defined_events=nb_defined_events;

//printf("END of parsing \n");

return parseresult;
}



