#include "unit/unit.h"
#include <stdio.h>

#include "socket/socket.h"
#include "event/eventqueue_table.h"
#include "event/event.h"
#include "parser/parser.h"





void rmiproxy_unit_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout, "RMIPROXY");
	unit_event_received(evt, node);
}


UNIT_PTR rmiproxy_unit_create2(char* sm_filename)
{

	
	UNIT_PTR u = unit_create(sm_filename, NULL);
	fprintf(stdout, "Creating RMIPROXY unit %p\n", u);
	COMPOSER_PTR c = rmiproxy_composer_create(u);
	char key1[255];
	strcpy(key1, "RMIPROXY");
	unit_addcomposer(u, key1, c);
	
 	

	 
	 u->func_event_received = rmiproxy_unit_event_received; 
	 
	return u;	
}



