#ifndef _PROXYCOMPOSER_H_
#define _PROXYCOMPOSER_H_

#include "composer/composer.h"


#define DEFAULT_JAVA_PACKAGE "defaultPkg."

typedef struct proxy_service_discover {
	int stream_id;
	SERVICEDEFPTR service_ptr;
} PROXY_SERVICE_DISCOVER;
typedef PROXY_SERVICE_DISCOVER* PROXY_SERVICE_DISCOVER_PTR;


typedef struct proxy_service_discover_table {
	PROXY_SERVICE_DISCOVER services[100];
	int n_services;
} PROXY_SERVICE_DISCOVER_TABLE;

void proxy_service_discover_table_init(PROXY_SERVICE_DISCOVER_TABLE* table);
void proxy_service_discover_table_add_entry(PROXY_SERVICE_DISCOVER_TABLE* table, int stream_id, SERVICEDEFPTR service_ptr);
int proxy_service_discover_table_contains_stream_id(PROXY_SERVICE_DISCOVER_TABLE table, int stream_id);
SERVICEDEFPTR proxy_service_discover_table_get_service_by_stream_id(PROXY_SERVICE_DISCOVER_TABLE table, int stream_id);

#define REMOTESTUB_CLASS_SERIALNUMBER -1585587260594494182ULL
#define REMOTEOBJECT_CLASS_SERIALNUMBER -3215090123894869218ULL

#define RMI_OBJNUM 0
//#define RMI_OBJUNIQUE 32635808
#define RMI_OBJTIME	1234
#define RMI_OBJCOUNT SHRT_MIN

static int RMI_OBJUNIQUE = 32635808;

#endif //_PROXYCOMPOSER_H_





