#ifndef _JCONST_H_
#define _JCONST_H_
#endif //_JCONST_H_
#ifndef _JTYPE_H_
#include <io/jtype.h>
#endif //_JCONST_H_
#define STREAM_MAGIC	((j_short) 0xaced)
#define STREAM_VERSION	5
#define JRMP_MAGIC  ((j_short)0x4a524d49)
#define TC_BASE 				 0x70;
#define TC_NULL 				 (j_byte)0x70 
#define TC_REFERENCE 			 (j_byte)0x71 
#define TC_CLASSDESC 			 (j_byte)0x72 
#define TC_OBJECT 				 (j_byte)0x73 
#define TC_STRING 				 (j_byte)0x74 
#define TC_ARRAY 				 (j_byte)0x75 
#define TC_CLASS 				 (j_byte)0x76 
#define TC_BLOCKDATA			 (j_byte)0x77 
#define TC_ENDBLOCKDATA 		 (j_byte)0x78 
#define TC_RESET 				 (j_byte)0x79 
#define TC_BLOCKDATALONG 		 (j_byte)0x7A 
#define TC_EXCEPTION 			 (j_byte)0x7B 
#define TC_MAX 					 (j_byte)0x7B
#define TC_PROXYCLASSDESC 		 (j_byte)0x7D 
#define baseWireHandle 				0x7e0000 //int
#define SC_NULLREFERENCE 	= baseWireHandle - 1; //int
#define SC_WRITE_METHOD 	0x01
#define SC_BLOCK_DATA   	0x01 // jdk1.2
#define SC_SERIALIZABLE 	0x02
#define SC_EXTERNALIZABLE 	0x04
#define BYTE_TYPE    = (byte) 'B';
#define CHAR_TYPE    = (byte) 'C';
#define DOUBLE_TYPE  = (byte) 'D';
#define FLOAT_TYPE   = (byte) 'F';
#define INT_TYPE     = (byte) 'I';
#define LONG_TYPE    = (byte) 'J';
#define SHORT_TYPE   = (byte) 'S';
#define BOOLEAN_TYPE = (byte) 'Z';
#define ARRAY_TYPE   = (byte) '[';
#define OBJECT_TYPE  = (byte) 'L';
