#ifndef _OBJECTPARSER_H_
#define _OBJECTPARSER_H_

#ifndef _JCONST_H_
#include <io/jconst.h>
#endif //_JCONST_H_
#ifndef _JTYPE_H_
#include <io/jtype.h>
#endif //_JTYPE_H_
#ifndef _CLASSDESCRIPTION_H_
#include <ser/classdescription.h>
#endif //_CLASSDESCRIPTION_H_

void* parseObjectOutputStream(int fd);

void parseClass(int fd);
void parseArray(int fd);
void parseReference(int fd);
void parseFlags(int fd,j_byte *flags);
int parseFields(int fd, SER_FIELDPTR* fields);
char * parseString(int fd);
CLASSDESCPTR parseClassDescription(int fd);
CLASSDESCPTR parseClassDesc(int fd);
void parseObjectData(int fd,CLASSDESCPTR desc, OBJECTDESCPTR objDesc );
int parseFieldDesc(int fd, SER_FIELDPTR field);
char * parseAnnotation(int fd);

#endif //_OBJECTPARSER_H_
