#ifndef _JMETHODS_H_
#define _JMETHODS_H_

#include <kazlib/list.h>

/*
typedef struct JMethods
{
	char**	methNames;
	char** 	methSignatures;
	int 	nMeths;
} JMETHODS;
typedef JMETHODS* JMETHODS_PTR;


JMETHODS_PTR create_JMethods();
*/





typedef struct JMethods
{
	int 	nMeths;
	list_t*	methods;

} JMETHODS;
typedef JMETHODS* JMETHODS_PTR;

typedef struct JMethod
{
        char*   methName;
        char*   methSignature;
        int     nArgs;
        char**  args_names;
        char**  args_types;
} JMETHOD;
typedef JMETHOD* JMETHOD_PTR;




JMETHODS_PTR create_JMethods();
JMETHOD_PTR create_JMethod();
JMETHOD_PTR create_JMethod_2(char* name, char* signature);
int JMethod_add_arg(JMETHOD_PTR meth, char* name, char* type);



#endif
