#include "composer/composer.h"
#include "unit/unit.h"

#include "io/io.h"
#include <stdio.h>
#include "event/eventqueue_table.h"
#include <pthread.h>



void *upnp_run_composer(void* ptr)
{
	COMPOSETHREADDATA_PTR data = (COMPOSETHREADDATA_PTR)ptr;
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = (EVENTQUEUE_TABLE_ENTRY_PTR)data->entry_event_queue;
	COMPOSER_PTR composer = (COMPOSER_PTR)data->composer;
	
	
	//EVENTQUEUE_TABLE_ENTRY_PTR entry = (EVENTQUEUE_TABLE_ENTRY_PTR)ptr;
	
	//pthread_t thread_event_src = pthread_self();
	//fprintf(stdout, "\nSLP PTHREAD composer = %p\n", thread_event_src);
	
	//slp_parse_msg(data->parser, data->msg->data, data->msg->length, thread_event_src);
	
	//eventqueue_table_print(eventqueue_table);
	//fprintf(stdout,"table contains 13,456 = %d\n", eventqueue_table_contain_entry(eventqueue_table, 13,456));
	
	while (1)
	{
		EVENT_PTR evt = eventqueue_table_get_event(entry);
		if (evt != NULL)
			fprintf(stdout,"upnp_run_composer: evt is type=%d, src=%p\n", evt->type,evt->stream_id);  	
		//else
		//	fprintf(stdout,"slp_run_composer: NO evt !\n"); 
		//sleep(10);
	}
}

COMPOSER_PTR upnpcomposer_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating UPnP composer\n");
		
	
	COMPOSER_PTR c = composer_create(u);

	c->run_composer = upnp_run_composer;
	c->factory = upnpcomposer_create;

	
	return c;	
}
