#include "monitor/tools.h"
#include <string.h>


void parseURL_nopath_path(char *location, char **location_url_nopath, char** location_url_path)
{
//	char* location_url_nopath;
//	char* location_url_path;
	//http://128.93.8.23:4004/description.xml
		

	char* first_str = strstr (location, "//");
	if (first_str != NULL)
	{
		char* last_char = strchr(first_str+2, '/');
		
		if (last_char != NULL)
		{
			*location_url_nopath = (char*)strndup(location, (int)(last_char - location +1));
			*location_url_path = strdup(last_char );
			fprintf(stdout,"\n 1 location=%s,  location_url_nopath=%s location_url_path=%s  \n",location ,*location_url_nopath, *location_url_path);
		}
		else
		{
			*location_url_nopath = strdup(location);
			*location_url_path = NULL;
			fprintf(stdout,"\n 2 location=%s,  location_url_nopath=%s location_url_path=%s  \n",location ,*location_url_nopath,*location_url_path);
		}
	}
	else
	{
		*location_url_nopath = NULL;
		*location_url_path = NULL;
	}
}

void parseURL_host_port(char *url_input, char **ip, int *port, char** url)
{
	//printf("\nThe URL to parse is %s\n",url);
	
	if(url_input != NULL && (strstr(url_input,"http://") != NULL || strstr(url_input,"rmi://") != NULL))
	{
		char str_protocol[10];
		if (strstr(url_input,"http://") != NULL)
			strcpy(str_protocol, "http://");
		else if (strstr(url_input,"rmi://") != NULL)
			strcpy(str_protocol, "rmi://");
			
		char *url_extract = (char*)malloc(sizeof(char)*(strlen(url_input)-strlen(str_protocol/*"http://"*/)+1));
		int index = 0;
		for(index = 0 ; index < (strlen(url_input)-strlen(str_protocol/*"http://"*/)) ; index++)
		{
			url_extract[index] = url_input[index+strlen(str_protocol/*"http://"*/)];
		}
		url_extract[index] = '\0';
		printf("\nExtracted url is %s\n",url_extract);
		for(index = 0; index < strlen(url_extract) ; index++)
		{
			if(url_extract[index] == '/')
				break;			
		}
		
		int start_index = 0;
		char *address = (char*)malloc(sizeof(char)*index);
		
		for(start_index = 0;start_index < index ; start_index++)
			address[start_index] = url_extract[start_index];
		
		//printf("\nExtracted Address is %s\n",address);

		char *token = NULL , seps[] = ":";	
		int counter = 0;
		
		token = strtok( address, seps );
		
		while( token != NULL )
		{
			if(counter == 0 )
				*ip = strdup(token);
			else
				*port = atoi(token);
			counter++;
			token = strtok( NULL, seps );
		}
				
		printf("\nIP is %s PORT is %d\n",*ip,*port);
		
		char *final_url = (char*)malloc(sizeof(char)*(strlen(url_extract)-index+1));
		
		int index2 = 0;
		for(index2 = 0 ; index2 < (strlen(url_extract)-index) ; index2++)
			final_url[index2] = url_extract[index2+index];
		
			printf("\nExtracted Final URL is %s\n",final_url);
			*url = strdup(final_url);
	}	
	else
	{
		printf("\nMalformed URL received\n");
	}	
}

void set_host_ip()
{
	char name[100];
	size_t lg;
	gethostname(name, lg);
	printf("\nhost name=%s, length=%d\n",name,lg);
	
	struct hostent * h;
	h = (struct hostent *)gethostbyname(name);
	
	printf("\nh_name=%s \nh_addrtype=%d \nh_length=%d \n", h->h_name, h->h_addrtype, h->h_length);
	
	struct in_addr* addr0 = (struct in_addr*)h->h_addr;
	char* addr_str = inet_ntoa(*addr0);	
	printf("\naddr_str=%s \n",addr_str);

	int i;
	for (i=0; h->h_addr_list[i] != NULL; i++)
	{
		struct in_addr* addr1 = (struct in_addr*)h->h_addr_list[i];
		printf("\naddr1=%p \n",addr1);
		char* addr1_str = inet_ntoa(*addr1);	
		printf("\naddr1_str=%s \n",addr1_str);
	}
	
	//return addr_str; //"192.168.2.2"; //
	machine_ip_address = strdup(addr_str);
	machine_ip_address_set = 1;
}



char *get_host_ip()
{
	if (machine_ip_address_set)
		return machine_ip_address;
	else
	{
		set_host_ip();
		return machine_ip_address;
	}
}

int replace_dot_with_slash(char* input, char* output)
{
	if (input == NULL)
		output = NULL;
	else 
	{
		int i;
		for(i = 0; i<strlen(input);i++)
		{
			if(input[i]=='.')
				output[i] = '/';
			else 
				output[i] = input[i];
		}
		output[strlen(input)] = '\0';
	}
}


int replace_slash_with_dot(char* input, char* output)
{
	if (input == NULL)
		output = NULL;
	else 
	{
		int i;
		for(i = 0; i<strlen(input);i++)
		{
			if(input[i]=='/')
				output[i] = '.';
			else 
				output[i] = input[i];
		}
		output[strlen(input)] = '\0';
	}
}

int replace_slash_with_$(char* input, char* output)
{
	int i;
	for(i = 0; i<strlen(input);i++)
	{
		if(input[i]=='/')
			output[i] = '$';
		else 
			output[i] = input[i];
	}
	output[strlen(input)] = '\0';
}


int get_httpserver_port()
{
	return 8080;
}


char* set_httpserver_path(char* value)
{
	if (value != NULL)		
		httpserver_path = strdup(value);
	else
		httpserver_path = NULL;
}

char* get_httpserver_path()
{
	return httpserver_path;
}

char* get_httpserver_urlpath()
{
	return"/tmp";
}

int get_soapproxy_port()
{
	return 10000;
}

int get_rmiregistry_port()
{
	return 1100;
}

//int ExtractContentLength(char *Header)
char* ExtractHeaderField(char *Header, char *field_name)
{
	char temp[MAX_LEN];
	memcpy(temp,Header,strlen(Header)+1);
	
	char *token=NULL,seps[]="\r\n",colon[]=":",*str_field=NULL,*val_field=NULL;

	token = strtok(/* Header*/temp, seps );
	while( token != NULL )
	{		
		if(strstr(token,field_name /*STR_CONTENTLENGTH*/) != NULL)
		{
			str_field = token;
			break;
		}		
		token = strtok( NULL, seps );
	}
	//printf("%s\n",str_contentlength);
	
	token = strtok( str_field, colon );
	while( token != NULL )
	{
		//printf("%s\n",token);	
		if(strstr(token, field_name /*STR_CONTENTLENGTH*/) == NULL)
		{
			val_field = token;
			break;
		}				
		token = strtok( NULL, colon );
	}	
	
	//printf("The content length is : %s, and integer as %d\n",val_contentlength,atoi(val_contentlength));		
	
	//return atoi(val_contentlength);
	return val_field;
}

char* ExtractHTTPDirective(char *Header, char *directive_name)
{
	char temp[MAX_LEN];
	memcpy(temp,Header,strlen(Header)+1);
	
	char *token=NULL,seps[]="\r\n",space[]=" ",*str_field=NULL,*val_field=NULL;

	token = strtok(/* Header*/temp, seps );
	while( token != NULL )
	{		
		if(strstr(token,directive_name /*STR_CONTENTLENGTH*/) != NULL)
		{
			str_field = token;
			break;
		}		
		token = strtok( NULL, seps );
	}
	//printf("%s\n",str_contentlength);
	
	token = strtok( str_field, space );
	while( token != NULL )
	{
		//printf("%s\n",token);	
		if(strstr(token, directive_name /*STR_CONTENTLENGTH*/) == NULL)
		{
			val_field = token;
			break;
		}				
		token = strtok( NULL, space );
	}	
	
	//printf("The content length is : %s, and integer as %d\n",val_contentlength,atoi(val_contentlength));		
	
	//return atoi(val_contentlength);
	return val_field;
}






j_long calc_method_hash(char* hash_method_name)
{
	   SHA1Context sha;
	    int i, j, err;
	    uint8_t Message_Digest[20];

	    	fprintf(stdout," calc_method_hash: method= %s\n",hash_method_name);
	    	UTF8_PTR utf8string = stringToUTF8(hash_method_name); //"stop(I)Ljava/lang/String;");   //echo(Ljava/lang/String;)Ljava/lang/String;") ;
	    	fprintf(stdout,"SHA signature length = %d\n",utf8string->size);
	    	fprintf(stdout,"SHA UTF8 string = ",utf8string->size);


	    for(i = 0; i < utf8string->size ; ++i)
	            {
	                fprintf(stdout,"%02X ", utf8string->utf8[i]);
	            }
	            fprintf(stdout,"\n");



	        fprintf( stdout, "\nTest : '%s'\n",
	                utf8string->utf8);
	//
	        err = SHA1Reset(&sha);
	        if (err)
	        {
	            fprintf(stdout, "SHA1Reset Error %d.\n", err );
	        }

	            err = SHA1Input(&sha,
	                  (const unsigned char *) utf8string->utf8,utf8string->size);
			     // strlen(utf8string->utf8) 
	            if (err)
	            {
	                fprintf(stdout, "SHA1Input Error %d.\n", err );
	            }


	        err = SHA1Result(&sha, Message_Digest);
	        if (err)
	        {
	            fprintf(stdout,
	            "SHA1Result Error %d, could not compute message digest.\n",
	            err );
	        }
	        else
	        {
	            printf("\t");
	            for(i = 7; i >= 0 ; i--)
	            {
	                fprintf(stdout,"%02X ", Message_Digest[i]);
	            }
	            fprintf(stdout,"\n");
	        }





		j_long hash = 4935908334937214722ULL; //6163373583986838439ULL; // tutu() : 3 integers args
		

		j_long calcHash = 0;
		calcHash = (((uint64)Message_Digest[7]&0x00000000000000ff) << 56) | (((uint64)Message_Digest[6]&0x00000000000000ff) << 48) | 
			   (((uint64)Message_Digest[5]&0x00000000000000ff) << 40) | (((uint64)Message_Digest[4]&0x00000000000000ff) << 32) | 
			   (((uint64)Message_Digest[3]&0x00000000000000ff) << 24) | (((uint64)Message_Digest[2]&0x00000000000000ff) << 16) |
			   (((uint64)Message_Digest[1]&0x00000000000000ff) << 8)  | ((uint64)Message_Digest[0]&0x00000000000000ff);
		fprintf(stdout, "\nHASH value = %lld ",hash);
		fprintf(stdout, "\nHASH Calc value = %lld ",calcHash);

		return calcHash;
}



